﻿using System;
using System.Reflection;
using Autofac;

namespace GestionConcesionarios.Aplicacion.Core.Container
{
  public static class ApplicationContainerBuilderHelper
  {
    #region Metodos Publicos

    public static IContainer BuildApplicationContainer(Assembly assemblyMappings, 
                                                       string[] namespaces,
                                                       Assembly[] applicationAssemblies, 
                                                       Assembly[] modelAssemblies)
    {
      if (modelAssemblies == null) throw new ArgumentNullException("modelAssemblies");
      if (assemblyMappings == null && modelAssemblies.Length == 0) throw new ArgumentException("assemblyMappings or modelAssemblies must be specified");
      if (namespaces == null) throw new ArgumentNullException("namespaces");
      if (applicationAssemblies == null) throw new ArgumentNullException("applicationAssemblies");
      if (namespaces.Length == 0) throw new ArgumentException("No namespaces to scan", "namespaces");

      var builder = new ContainerBuilder();
      
      builder.RegisterModule(new ApplicationModule(namespaces, applicationAssemblies));
      
      return builder.Build();
    }
    
    #endregion
  }
}
