﻿using System;
using System.Collections.Generic;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionContenidosReparaciones
{
  /// <summary>
  /// Contrato base para las operaciones en la capa de Aplicación de los contenidos de Reparacion
  /// </summary>
  public interface IGestionContenidoReparacionService
  {
    /// <summary>
    /// Añadir un nuevo contenidoReparacion
    /// </summary>
    /// <param name="contenidoReparacion">ContenidoReparacion a añadir</param>
    void AddContenidoReparacion(ContenidoReparacion contenidoReparacion);

    /// <summary>
    /// Añadir un nuevo contenidoReparacion
    /// </summary>    
    void AddContenidoReparacion();

    /// <summary>
    /// Modificar un contenidoReparacion existente
    /// </summary>
    /// <param name="contenidoReparacion">ContenidoReparacion con cambios a modificar</param>
    void ChangeContenidoReparacion(ContenidoReparacion contenidoReparacion);

    /// <summary>
    /// Modificar un contenidoReparacion existente
    /// </summary>
    /// <param name="idGuid">Identificador único del contenidoReparacion a modificar </param>    
    void ChangeContenidoReparacion(Guid idGuid);

    /// <summary>
    /// Borrar un contenidoReparacion existente 
    /// </summary>
    /// <param name="contenidoReparacion">ContenidoReparacion a eliminar</param>
    void RemoveContenidoReparacion(ContenidoReparacion contenidoReparacion);

    /// <summary>
    /// Borrar un contenidoReparacion existente 
    /// </summary>
    /// <param name="idGuid">Identificador único del contenidoReparacion a eliminar</param>
    void RemoveContenidoReparacion(Guid idGuid);

    /// <summary>
    /// Buscar contenidoReparacion por el valor de la propiedad Id
    /// </summary>
    /// <param name="id">Especificación de Id del contenidoReparacion</param>
    /// <returns>Lista de contenidoReparacions si existen o null si no existen contenidoReparacions con el valor id igual a <paramref name="id"/></returns>
    List<ContenidoReparacion> BuscarContenidoReparacionPorId(Guid? id);
  }
}