﻿using System;
using System.Collections.Generic;
using GestionConcesionarios.Aplicacion.Core.Container;
using GestionConcesionarios.Dominio.ModuloPrincipal.EstadosOrdenReparacion;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionEstadosOrdenReparacion
{
  /// <summary>
  /// Implementación de IGestionTipoVehiculoService
  /// </summary>
  public class GestionEstadoOrdenReparacionService : IAplicacionService, IGestionEstadoOrdenReparacionService
  {
    #region Atributos

    readonly IEstadoOrdenReparacionRepository _estadoOrdenReparacionRepository;

    #endregion

    #region Constructor

    /// <summary>
    /// Crear una nueva instancia 
    /// </summary>
    /// <param name="estadoOrdenReparacionRepository">Dependencia al repositorio de Tipos de vehiculo, será resuelta automáticamente por el contenedor IoC (Autofac) con la inyección de dependencia</param>
    public GestionEstadoOrdenReparacionService(IEstadoOrdenReparacionRepository estadoOrdenReparacionRepository)
    {
      if (estadoOrdenReparacionRepository == null) throw new ArgumentNullException("estadoOrdenReparacionRepository");

      _estadoOrdenReparacionRepository = estadoOrdenReparacionRepository;
    }

    #endregion

    #region Miembros de IGestionEstadoOrdenReparacionService

    /// <summary>
    /// <see cref="IGestionEstadoOrdenReparacionService"/>
    /// </summary>
    /// <returns><see cref="EstadoOrdenReparacion"/></returns>
    public List<EstadoOrdenReparacion> BuscarTodosLosEstadosOrdenReparacion()
    {
      return _estadoOrdenReparacionRepository.BuscarTodosLosEstadosOrdenReparacion();
    }
    #endregion
  }
}
