﻿using System;
using System.Collections.Generic;
using GestionConcesionarios.Aplicacion.Core.Container;
using GestionConcesionarios.Dominio.ModuloPrincipal.EstadosReparacion;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionEstadosReparacion
{
  /// <summary>
  /// Implementación de IGestionEstadoReparacionService
  /// </summary>
  public class GestionEstadoReparacionService : IAplicacionService, IGestionEstadoReparacionService
  {
    #region Atributos

    readonly IEstadoReparacionRepository _estadoReparacionRepository;

    #endregion

    #region Constructor

    /// <summary>
    /// Crear una nueva instancia 
    /// </summary>
    /// <param name="estadoReparacionRepository">Dependencia al repositorio de estados reparación, será resuelta automáticamente por el contenedor IoC (Autofac) con la inyección de dependencia</param>
    public GestionEstadoReparacionService(IEstadoReparacionRepository estadoReparacionRepository)
    {
      if (estadoReparacionRepository == null) throw new ArgumentNullException("estadoReparacionRepository");

      _estadoReparacionRepository = estadoReparacionRepository;
    }

    #endregion

    #region Miembros de IGestionEstadoReparacionService

    /// <summary>
    /// <see cref="IGestionEstadoReparacionService"/>
    /// </summary>
    /// <returns><see cref="EstadoReparacion"/></returns>
    public List<EstadoReparacion> BuscarTodosLosEstadosReparacion()
    {
      return _estadoReparacionRepository.BuscarTodosLosEstadosReparacion();
    }
    #endregion
  }
}
