﻿using System;
using System.Collections.Generic;
using GestionConcesionarios.Aplicacion.Core.Container;
using GestionConcesionarios.Dominio.ModuloPrincipal.FormasDePago;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionFormasDePago
{
  /// <summary>
  /// Implementación de IGestionFormaDePagoService
  /// </summary>
  public class GestionFormaDePagoService : IAplicacionService, IGestionFormaDePagoService
  {
    #region Atributos

    readonly IFormaDePagoRepository _formaDePagoRepository;

    #endregion

    #region Constructor

    /// <summary>
    /// Crear una nueva instancia 
    /// </summary>
    /// <param name="formaDePagoRepository">Dependencia al repositorio de formasDePago, será resuelta automáticamente por el contenedor IoC (Autofac) con la inyección de dependencia</param>
    public GestionFormaDePagoService(IFormaDePagoRepository formaDePagoRepository)
    {
      if (formaDePagoRepository == null) throw new ArgumentNullException("formaDePagoRepository");

      _formaDePagoRepository = formaDePagoRepository;
    }

    #endregion

    #region Miembros de IGestionFormaDePagoService

    /// <summary>
    /// <see cref="GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionFormasDePago.IGestionFormaDePagoService"/>
    /// </summary>
    /// <returns><see cref="FormaDePago"/></returns>
    public List<FormaDePago> BuscarTodasLasFormasDePago()
    {
      return _formaDePagoRepository.BuscarFormaDePago();
    }
    #endregion
  }
}
