﻿using System.Collections.Generic;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionModelos
{
  /// <summary>
  /// Contrato base para las operaciones en la capa de Aplicación de los modelos
  /// </summary>
  public interface IGestionModeloService
  {
    /// <summary>
    /// Buscar modelos por el valor de la propiedad idMarca a la que pertenecen
    /// </summary>
    /// <param name="idMarca">Especificación de idMarca de los modelos a buscar</param>
    /// <returns>Lista de modelos si existen o null si no existen modelos con el valor idMarca igual a <paramref name="idMarca"/></returns>
    List<Modelo> BuscarListaModeloPorIdMarca(string idMarca);

    /// <summary>
    /// Encontrar todos los modelos
    /// </summary>
    /// <returns>Todas los modelos</returns>
    IList<Modelo> BuscarTodosLosModelos();
  }
}
