﻿using System.Collections.Generic;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionPoblaciones
{
  /// <summary>
  /// Contrato base para las operaciones en la capa de Aplicación de las poblaciones
  /// </summary>
  public interface IGestionPoblacionService
  {
    /// <summary>
    /// Buscar poblaciones por el valor de la propiedad idProvincia a la que pertenecen
    /// </summary>
    /// <param name="idProvincia">Especificación de idProvincia de las poblaciones a buscar</param>
    /// <returns>Lista de poblaciones si existen o null si no existen poblaciones con el valor idProvincia igual a <paramref name="idProvincia"/></returns>
    List<Poblacion> BuscarListaPoblacionPorIdProvincia(string idProvincia);
  }
}
