﻿using System;
using System.Collections.Generic;
using GestionConcesionarios.Aplicacion.Core.Container;
using GestionConcesionarios.Dominio.ModuloPrincipal.Provincias;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionProvincias
{
  /// <summary>
  /// Implementación de IGestionProvinciaService
  /// </summary>
  public class GestionProvinciaService : IAplicacionService, IGestionProvinciaService
  {
    #region Atributos

    readonly IProvinciaRepository _provinciaRepository;

    #endregion

    #region Constructor

    /// <summary>
    /// Crear una nueva instancia 
    /// </summary>
    /// <param name="provinciaRepository">Dependencia al repositorio de provincias, será resuelta automáticamente por el contenedor IoC (Autofac) con la inyección de dependencia</param>
    public GestionProvinciaService(IProvinciaRepository provinciaRepository)
    {
      if (provinciaRepository == null) throw new ArgumentNullException("provinciaRepository");

      _provinciaRepository = provinciaRepository;
    }

    #endregion

    #region Miembros de IGestionCodigoPostalService

    /// <summary>
    /// <see cref="IGestionProvinciaService"/>
    /// </summary>
    /// <returns><see cref="Provincia"/></returns>
    public List<Provincia> BuscarTodasLasProvincias()
    {
      return _provinciaRepository.BuscarProvincia();
    }
    #endregion
  }
}
