﻿using System;
using System.Collections.Generic;
using GestionConcesionarios.Aplicacion.Core.Container;
using GestionConcesionarios.Dominio.ModuloPrincipal.TiposDeVehiculo;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Aplicacion.ModuloPrincipal.GestionTiposVehiculo
{
  /// <summary>
  /// Implementación de IGestionTipoVehiculoService
  /// </summary>
  public class GestionTipoVehiculoService : IAplicacionService, IGestionTipoVehiculoService
  {
    #region Atributos

    readonly ITipoVehiculoRepository _tipoVehiculoRepository;

    #endregion

    #region Constructor

    /// <summary>
    /// Crear una nueva instancia 
    /// </summary>
    /// <param name="tipoVehiculoRepository">Dependencia al repositorio de Tipos de vehiculo, será resuelta automáticamente por el contenedor IoC (Autofac) con la inyección de dependencia</param>
    public GestionTipoVehiculoService(ITipoVehiculoRepository tipoVehiculoRepository)
    {
      if (tipoVehiculoRepository == null) throw new ArgumentNullException("tipoVehiculoRepository");

      _tipoVehiculoRepository = tipoVehiculoRepository;
    }

    #endregion

    #region Miembros de IGestionTipoVehiculoService

    /// <summary>
    /// <see cref="IGestionTipoVehiculoService"/>
    /// </summary>
    /// <returns><see cref="TipoVehiculo"/></returns>
    public List<TipoVehiculo> BuscarTodosLosTiposDeVehiculo()
    {
      return _tipoVehiculoRepository.BuscarTipoVehiculo();
    }
    #endregion
  }
}
