﻿//===================================================================================
// Microsoft Developer & Platform Evangelism
//=================================================================================== 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
//===================================================================================
// Copyright (c) Microsoft Corporation.  All Rights Reserved.
// This code is released under the terms of the MS-LPL license, 
// http://microsoftnlayerapp.codeplex.com/license
//===================================================================================

namespace GestionConcesionarios.Dominio.Core.Specification
{
  /// <summary>
  /// Base class for composite specifications
  /// </summary>
  /// <typeparam name="TEntity">Type of entity that check this specification</typeparam>
  public abstract class CompositeSpecification<TEntity>
       : Specification<TEntity>
       where TEntity : class
  {
    #region Properties

    /// <summary>
    /// Left side specification for this composite element
    /// </summary>
    public abstract ISpecification<TEntity> LeftSideSpecification { get; }

    /// <summary>
    /// Right side specification for this composite element
    /// </summary>
    public abstract ISpecification<TEntity> RightSideSpecification { get; }

    #endregion
  }
}
