﻿namespace GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo
{
  public partial class PaqueteDeServicio
  {
    #region Propiedades

    public decimal Precio
    {
      get
      {
        decimal? precioPaqueteServicio = 0;
        foreach (var paquete in Paquete)
        {
          decimal? precioPaquete = 0;
          if (paquete.ManoDeObra != null)
            precioPaquete += ((paquete.ManoDeObra.PrecioPorHora * paquete.ManoDeObra.Duracion * paquete.Cantidad) / 60);
          if (paquete.Articulo != null)
            precioPaquete += (paquete.Articulo.CosteActual * paquete.Cantidad);

          precioPaqueteServicio += precioPaquete;
        }
        return precioPaqueteServicio.HasValue ? precioPaqueteServicio.Value : 0;
      }
    }

    public decimal DuracionSugerida
    {
      get
      {
        decimal? duracionSugeridaPaqueteServicio = 0;
        foreach (var paquete in Paquete)
        {
          decimal? duracionPaquete = 0;
          if (paquete.ManoDeObra != null)
            duracionPaquete += (paquete.ManoDeObra.Duracion * paquete.Cantidad);

          duracionSugeridaPaqueteServicio += duracionPaquete;
        }
        return duracionSugeridaPaqueteServicio.HasValue ? duracionSugeridaPaqueteServicio.Value : 0;
      }
    }

    #endregion
  }
}
