﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Articulos
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Articulo
  /// </summary>
  public interface IArticuloRepository : IRepository<Articulo>
  {
    /// <summary>
    /// Buscar Articulos por la especificación a satisfacer del Articulo
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Articulos seleccionados que coinciden con la especificación</returns>
    List<Articulo> BuscarArticulo(ISpecification<Articulo> specification);
  }
}