﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.ArticulosAlmacen
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' ArticuloAlmacen
  /// </summary>
  public interface IArticuloAlmacenRepository : IRepository<ArticuloAlmacen>
  {
    /// <summary>
    /// Buscar ArticuloAlmacens por la especificación a satisfacer del ArticuloAlmacen
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de ArticuloAlmacens seleccionados que coinciden con la especificación</returns>
    List<ArticuloAlmacen> BuscarArticuloAlmacen(ISpecification<ArticuloAlmacen> specification);
  }
}