﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.CategoriasArticulos
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' CategoriaArticulo
  /// </summary>
  public interface ICategoriaArticuloRepository : IRepository<CategoriaArticulo>
  {
    /// <summary>
    /// Buscar CategoriaArticulos por la especificación a satisfacer del CategoriaArticulo
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de CategoriaArticulos seleccionados que coinciden con la especificación</returns>
    List<CategoriaArticulo> BuscarCategoriaArticulo(ISpecification<CategoriaArticulo> specification);

    /// <summary>
    /// Buscar todas las categorias de articulo
    /// </summary>
    /// <returns>Lista de todas las categorias de articulo</returns>
    List<CategoriaArticulo> BuscarTodasLasCategoriasArticulo();
  }
}