﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Clientes
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' cliente
  /// </summary>
  public interface IClienteRepository : IRepository<Cliente>
  {
    /// <summary>
    /// Buscar clientes por la especificación a satisfacer del cliente
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de clientes seleccionados que coinciden con la especificación</returns>
    List<Cliente> BuscarCliente(ISpecification<Cliente> specification);
  }
}
