﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.CodigosPostales
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Código Postal
  /// </summary>
  public interface ICodigoPostalRepository : IRepository<CodigoPostal>
  {
    /// <summary>
    /// Buscar todos los códigos postales
    /// </summary>
    /// <returns>Lista de todos los códigos postales</returns>
    List<CodigoPostal> BuscarCodigoPostal();
  }
}
