﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.ContenidosReparaciones
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' ContenidoReparacion
  /// </summary>
  public interface IContenidoReparacionRepository : IRepository<ContenidoReparacion>
  {
    /// <summary>
    /// Buscar ContenidoReparacions por la especificación a satisfacer del ContenidoReparacion
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de ContenidoReparacions seleccionados que coinciden con la especificación</returns>
    List<ContenidoReparacion> BuscarContenidoReparacion(ISpecification<ContenidoReparacion> specification);
  }
}