﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Empleados
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Empleado
  /// </summary>
  public interface IEmpleadoRepository : IRepository<Empleado>
  {
    /// <summary>
    /// Buscar Empleados por la especificación a satisfacer del Empleado
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Empleados seleccionados que coinciden con la especificación</returns>
    List<Empleado> BuscarEmpleado(ISpecification<Empleado> specification);

    /// <summary>
    /// Buscar todos los empleados
    /// </summary>
    /// <returns>Lista de todos los empleados</returns>
    List<Empleado> BuscarTodosLosEmpleados();
  }
}