﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.EstadosOrdenReparacion
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' EstadoOrdenReparacion
  /// </summary>
  public interface IEstadoOrdenReparacionRepository : IRepository<EstadoOrdenReparacion>
  {
    /// <summary>
    /// Buscar EstadosOrdenReparacion por la especificación a satisfacer del EstadoOrdenReparacion
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de EstadoOrdenReparacion seleccionados que coinciden con la especificación</returns>
    List<EstadoOrdenReparacion> BuscarEstadoOrdenReparacion(ISpecification<EstadoOrdenReparacion> specification);

    /// <summary>
    /// Buscar todos los estados orden de reparación
    /// </summary>
    /// <returns>Lista de todos los estados orden de reparación</returns>
    List<EstadoOrdenReparacion> BuscarTodosLosEstadosOrdenReparacion();
  }
}