﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.EstadosReparacion
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' EstadoReparacion
  /// </summary>
  public interface IEstadoReparacionRepository : IRepository<EstadoReparacion>
  {
    /// <summary>
    /// Buscar Estados Reparaciones por la especificación a satisfacer del EstadoReparacion
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de EstadoReparacion seleccionados que coinciden con la especificación</returns>
    List<EstadoReparacion> BuscarEstadoReparacion(ISpecification<EstadoReparacion> specification);

    /// <summary>
    /// Buscar todos los estados de reparación
    /// </summary>
    /// <returns>Lista de todas los estados de reparación</returns>
    List<EstadoReparacion> BuscarTodosLosEstadosReparacion();
  }
}