﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.ManosDeObra
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' ManoDeObra
  /// </summary>
  public interface IManoDeObraRepository : IRepository<ManoDeObra>
  {
    /// <summary>
    /// Buscar Manos De Obra por la especificación a satisfacer del ManoDeObra
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de ManoDeObra seleccionados que coinciden con la especificación</returns>
    List<ManoDeObra> BuscarManosDeObra(ISpecification<ManoDeObra> specification);
  }
}