﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Modelos
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Modelo
  /// </summary>
  public interface IModeloRepository : IRepository<Modelo>
  {
    /// <summary>
    /// Buscar modelos por la especificación a satisfacer del modelo
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de modelos seleccionados que coinciden con la especificación</returns>
    List<Modelo> BuscarModelo(ISpecification<Modelo> specification);

    /// <summary>
    /// Buscar todos los modelos
    /// </summary>
    /// <returns>Lista de todas los modelos</returns>
    List<Modelo> BuscarModelos();
  }
}
