﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.OrdenesReparacion
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' OrdenReparacion
  /// </summary>
  public interface IOrdenReparacionRepository : IRepository<OrdenReparacion>
  {
    /// <summary>
    /// Buscar Ordenes Reparacion por la especificación a satisfacer del OrdenReparacion
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de OrdenReparacion seleccionados que coinciden con la especificación</returns>
    List<OrdenReparacion> BuscarOrdenReparacion(ISpecification<OrdenReparacion> specification);
  }
}