﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Paquetes
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Paquete
  /// </summary>
  public interface IPaqueteRepository : IRepository<Paquete>
  {
    /// <summary>
    /// Buscar Paquetes por la especificación a satisfacer del Paquete
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Paquetes seleccionados que coinciden con la especificación</returns>
    List<Paquete> BuscarPaquete(ISpecification<Paquete> specification);
  }
}