﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.PaquetesDeServicio
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' PaqueteDeServicio
  /// </summary>
  public interface IPaqueteDeServicioRepository : IRepository<PaqueteDeServicio>
  {
    /// <summary>
    /// Buscar Paquetes De Servicio por la especificación a satisfacer del PaqueteDeServicio
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de PaqueteDeServicio seleccionados que coinciden con la especificación</returns>
    List<PaqueteDeServicio> BuscarPaqueteDeServicio(ISpecification<PaqueteDeServicio> specification);
  }
}