﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Poblaciones
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Población
  /// </summary>
  public interface IPoblacionRepository : IRepository<Poblacion>
  {
    /// <summary>
    /// Buscar poblaciones por la especificación a satisfacer de la población
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de poblaciones seleccionadas que coinciden con la especificación</returns>
    List<Poblacion> BuscarPoblacion(ISpecification<Poblacion> specification);
  }
}
