﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Presupuestos
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Presupuesto
  /// </summary>
  public interface IPresupuestoRepository : IRepository<Presupuesto>
  {
    /// <summary>
    /// Buscar Presupuestos por la especificación a satisfacer del Presupuesto
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Presupuestos seleccionados que coinciden con la especificación</returns>
    List<Presupuesto> BuscarPresupuesto(ISpecification<Presupuesto> specification);
  }
}