﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Proveedores
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Proveedor
  /// </summary>
  public interface IProveedorRepository : IRepository<Proveedor>
  {
    /// <summary>
    /// Buscar Proveedores por la especificación a satisfacer del Proveedore
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Proveedores seleccionados que coinciden con la especificación</returns>
    List<Proveedor> BuscarProveedor(ISpecification<Proveedor> specification);

    /// <summary>
    /// Buscar todos los proveedores, sin especificar criterios
    /// </summary>
    /// <returns>Lista de todos los proveedores</returns>
    List<Proveedor> BuscarProveedor();
  }
}