﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Recepciones
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Recepcion
  /// </summary>
  public interface IRecepcionRepository : IRepository<Recepcion>
  {
    /// <summary>
    /// Buscar Recepciones por la especificación a satisfacer del Recepcion
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Recepciones seleccionadas que coinciden con la especificación</returns>
    List<Recepcion> BuscarRecepcion(ISpecification<Recepcion> specification);
  }
}