﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Reparaciones
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Reparacion
  /// </summary>
  public interface IReparacionRepository : IRepository<Reparacion>
  {
    /// <summary>
    /// Buscar Reparaciones por la especificación a satisfacer del Reparacion
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Reparaciones seleccionadas que coinciden con la especificación</returns>
    List<Reparacion> BuscarReparacion(ISpecification<Reparacion> specification);
  }
}