﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Talleres
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Taller
  /// </summary>
  public interface ITallerRepository : IRepository<Taller>
  {
    /// <summary>
    /// Buscar Talleres por la especificación a satisfacer del Taller
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Talleres seleccionados que coinciden con la especificación</returns>
    List<Taller> BuscarTaller(ISpecification<Taller> specification);

    /// <summary>
    /// Buscar todos los talleres.
    /// </summary>
    /// <returns>Lista de todos los talleres</returns>
    List<Taller> BuscarTodosLosTalleres();
  }
}