﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.TiposDeCombustible
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Tipo de combustible
  /// </summary>
  public interface ITipoCombustibleRepository : IRepository<TipoCombustible>
  {
    /// <summary>
    /// Buscar todos los tipos de combustible
    /// </summary>
    /// <returns>Lista de todos los tipos de combustible</returns>
    List<TipoCombustible> BuscarTipoCombustible();
  }
}
