﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.TiposDeVehiculo
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' tipo de vehiculo
  /// </summary>
  public interface ITipoVehiculoRepository : IRepository<TipoVehiculo>
  {
    /// <summary>
    /// Buscar todos los tipos de vehiculo
    /// </summary>
    /// <returns>Lista de todos los tipos de vehiculo</returns>
    List<TipoVehiculo> BuscarTipoVehiculo();
  }
}
