﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.TiposEmpleado
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' TipoEmpleado
  /// </summary>
  public interface ITipoEmpleadoRepository : IRepository<TipoEmpleado>
  {
    /// <summary>
    /// Buscar Tipos Empleado por la especificación a satisfacer del TipoEmpleado
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de TipoEmpleado seleccionados que coinciden con la especificación</returns>
    List<TipoEmpleado> BuscarTipoEmpleado(ISpecification<TipoEmpleado> specification);

    /// <summary>
    /// Buscar todos los tipos de empleado
    /// </summary>
    /// <returns>Lista de todos los tipos de empleado</returns>
    List<TipoEmpleado> BuscarTodosLosTiposDeEmpleado();
  }
}