﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Vehiculos
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Vehiculo
  /// </summary>
  public interface IVehiculoRepository : IRepository<Vehiculo>
  {
    /// <summary>
    /// Buscar vehículos por la especificación a satisfacer del vehículo
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de vehículos seleccionados que coinciden con la especificación</returns>
    List<Vehiculo> BuscarVehiculo(ISpecification<Vehiculo> specification);
  }
}
