﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.VehiculosVenta
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' VehiculoVenta
  /// </summary>
  public interface IVehiculoVentaRepository : IRepository<VehiculoVenta>
  {
    /// <summary>
    /// Buscar vehículos de venta por la especificación a satisfacer del vehículo de venta
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de vehículos de venta seleccionados que coinciden con la especificación</returns>
    List<VehiculoVenta> BuscarVehiculoVenta(ISpecification<VehiculoVenta> specification);
  }
}
