﻿using System.Collections.Generic;
using GestionConcesionarios.Dominio.Core;
using GestionConcesionarios.Dominio.Core.Specification;
using GestionConcesionarios.Infraestructura.Data.ModuloPrincipal.Modelo;

namespace GestionConcesionarios.Dominio.ModuloPrincipal.Ventas
{
  /// <summary>
  /// Contrato para el repositorio del 'Aggregate Root' Venta
  /// </summary>
  public interface IVentaRepository : IRepository<Venta>
  {
    /// <summary>
    /// Buscar Ventas por la especificación a satisfacer del Venta
    /// </summary>
    /// <param name="specification">Especificacion a satisfacer</param>
    /// <returns>Lista de Ventas seleccionados que coinciden con la especificación</returns>
    List<Venta> BuscarVenta(ISpecification<Venta> specification);
  }
}