﻿using System;
using GestionConcesionarios.Presentacion.Infraestructura.Mediator;

namespace GestionConcesionarios.Presentacion.Base
{
  public class PresenterWithMediatorBase : PresenterBase, IDisposable
  {
    protected readonly IMediatorManager _mediatorManager;

    public PresenterWithMediatorBase(IMediatorManager mediatorManager)
    {
      _mediatorManager = mediatorManager;
    }

    public override void Dispose()
    {
      _mediatorManager.Unregister(this);
      base.Dispose();
    }
  }
}
