﻿using System;
using FluentValidation;
using GestionConcesionarios.Presentacion.CasosDeUso.Presupuestos;

namespace GestionConcesionarios.Presentacion.CasosDeUso.Almacen
{
  /// <summary>
  /// Para definir un conjunto de reglas de validación para un objeto en particular, hay que 
  /// crear una clase que herede de AbstractValidator <T/>, donde T es el tipo de
  /// Clase que se desea validar.
  /// Para mas información ir a http://fluentvalidation.codeplex.com/documentation
  /// </summary>
  public class EntradaAlAlmacenViewModelValidator : AbstractValidator<EntradaAlAlmacenViewModel>
  {
    /// <summary>
    /// Inicializa una nueva instancia de la clase<see cref="PresupuestoViewModelValidator" />.
    /// Configurando las reglas de validación a cumplir.
    /// </summary>
    public EntradaAlAlmacenViewModelValidator()
    {
      RuleFor(t => t.IdEmpleado).NotEmpty().NotEqual(Guid.Empty).WithMessage("Es necesario rellenar el campo");
    }
  }
}
