﻿using System;
using System.Windows.Forms;
using GestionConcesionarios.Presentacion.Base;
using GestionConcesionarios.Presentacion.CasosDeUso.Articulos;
using GestionConcesionarios.Presentacion.CasosDeUso.BuscarArticulo;

namespace GestionConcesionarios.Presentacion.CasosDeUso.Almacen
{
  public partial class FormEntradaAlAlmacen : BindableFormBase
  {
    #region Atributos

    private readonly EntradaAlAlmacenPresenter _entradaAlAlmacenPresenter;

    #endregion

    #region Constructores

    public FormEntradaAlAlmacen(EntradaAlAlmacenPresenter entradaAlAlmacenPresenter)
    {
      InitializeComponent();
      _entradaAlAlmacenPresenter = entradaAlAlmacenPresenter;
      ConfigurarAyuda(helpProviderFormEntradaAlAlmacen);
    }

    #endregion

    #region Manejadores de eventos

    private void FormEntradaAlAlmacen_Load(object sender, EventArgs e)
    {
      if (_entradaAlAlmacenPresenter != null)
      {
        _entradaAlAlmacenPresenter.NuevaEntradaAlAlmacen();
        _entradaAlAlmacenPresenter.SetModelReadOnly();
        _entradaAlAlmacenPresenter.SubscribirAccionesACambiosEnElModelo();
        bindingSourcePresenter.DataSource = _entradaAlAlmacenPresenter;
      }
      helpProviderFormEntradaAlAlmacen.SetShowHelp(this, true);
    }

    private void simpleButton3_Click(object sender, EventArgs e)
    {
      /*
      var formArticulos = new FormArticulos();
      formArticulos.ShowDialog();
      */
    }

    private void simpleButton1_Click(object sender, EventArgs e)
    {
      /*
      var formArticulo = new FormArticulo();
      formArticulo.ShowDialog();
      */
    }

    private void barLargeButtonItemSalir_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      Close();
    }

    private void barLargeButtonItemAyuda_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      Help.ShowHelp(this, helpProviderFormEntradaAlAlmacen.HelpNamespace);
    }
    
    private void barLargeButtonItemNuevo_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      _entradaAlAlmacenPresenter.NuevaEntradaAlAlmacen();
    }

    private void barLargeButtonItemGuardar_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      gridViewListaEntradas.PostEditor();
      _entradaAlAlmacenPresenter.GuardarEntradaAlAlmacen();
    }

    private void simpleButtonAgregar_Click(object sender, EventArgs e)
    {
      _entradaAlAlmacenPresenter.MostrarFormArticulos();
    }

    private void simpleButtonBorrar_Click(object sender, EventArgs e)
    {
      var articuloSeleccionado = gridViewListaEntradas.GetFocusedRow() as EntradaAlAlmacenViewModel.LineaEntradaAlAlmacenViewModel;
      if (articuloSeleccionado != null) _entradaAlAlmacenPresenter.EliminarArticuloDeLasEntradasAlAlmacen(articuloSeleccionado);
    }

    private void simpleButtonEditar_Click(object sender, EventArgs e)
    {
      // TODO: Falta editar un articulo añadido al almacén
      MessageBox.Show("Esta funcionalidad no esta implementada");
    }

    #endregion
  }
}