﻿using System;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.Articulos
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista del artículo
  /// </summary>
  public class ArticuloViewModel : ModelBase, IPersistentModel
  {
    #region Propiedades

    public virtual Guid Id { get; set; }
    public virtual string Nombre { get; set; }
    public virtual string Descripcion { get; set; }
    public virtual Guid? IdProveedor { get; set; }
    public virtual string IdCategoriaArticulo { get; set; }
    public virtual decimal? CosteActualPorUnidad { get; set; }
    public virtual decimal? CosteActualBuffer { get; set; }
    public virtual decimal? CosteAnteriorPorUnidad { get; set; }

    #endregion

    #region Métodos Publicos

    /// <summary>
    /// Determina si el modelo [ha estado persistido].
    /// </summary>
    /// <returns>
    ///   <c>true</c> Si [ha estado persistido]; de otra forma, <c>false</c>.
    /// </returns>
    public bool HasBeenPersisted()
    {
      return !Id.Equals(Guid.Empty);
    }
    #endregion
  }
}
