﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarArticulo
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar manos de obra
  /// </summary>
  public class BuscarArticuloViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarArticuloListItemModel> _listaBuscarArticulos = new BindingList<BuscarArticuloListItemModel>();
    
    #endregion

    #region Propiedades

    public BindingList<BuscarArticuloListItemModel> ListaBuscarArticulos
    {
      get { return _listaBuscarArticulos; }
      set { _listaBuscarArticulos = value; }
    }

    public virtual string Nombre { get; set; }
    public virtual Guid IdProveedor { get; set; }
    public virtual string IdCategoria { get; set; }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarArticuloListItemModel
  {
    public Guid ArticuloId { get; set; }
    public string Nombre { get; set; }
    public string Descripcion { get; set; }
    public Guid? IdProveedor { get; set; }
    public string IdCategoria { get; set; }
    public bool Seleccionar { get; set; }
    public decimal? CosteActual { get; set; }
  }
  
  #endregion
}
