﻿using DevExpress.XtraEditors.Repository;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarArticulo
{
  public partial class FormArticulos : BindableFormBase
  {
    #region Fields

    private readonly BuscarArticuloPresenter _buscarArticuloPresenter;

    #endregion

    #region Constructores

    public FormArticulos(BuscarArticuloPresenter buscarArticuloPresenter)
    {
      InitializeComponent();
      _buscarArticuloPresenter = buscarArticuloPresenter;
    }

    #endregion

    #region Manejadores de eventos

    private void barButtonItemNuevoArticulo_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      _buscarArticuloPresenter.MostrarFormArticulo();
      Close();
    }

    private void barButtonItemAsignarArticulo_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      _buscarArticuloPresenter.AsignarArticulos();
      Close();
    }

    private void FormArticulos_Load(object sender, System.EventArgs e)
    {
      if (_buscarArticuloPresenter != null)
      {
        _buscarArticuloPresenter.SetModelReadOnly();
        _buscarArticuloPresenter.NuevaBusqueda();
        _buscarArticuloPresenter.SubscribirAccionesACambiosEnElModelo();
        bindingSourcePresenter.DataSource = _buscarArticuloPresenter;
      }
    }

    private void repositoryItemCheckEdit2_EditValueChanged(object sender, System.EventArgs e)
    {
      gridViewListaArticulos.PostEditor();
    }
    #endregion
  }
}