﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarCliente
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar clientes
  /// </summary>
  public class BuscarClienteViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarClienteListItemModel> _listaBuscarClientes = new BindingList<BuscarClienteListItemModel>();
    
    #endregion

    #region Propiedades

    public BindingList<BuscarClienteListItemModel> ListaBuscarClientes
    {
      get { return _listaBuscarClientes; }
      set { _listaBuscarClientes = value; }
    }

    public virtual string Nombre { get; set; }
    public virtual string PrimerApellido { get; set; }
    public virtual string SegundoApellido { get; set; }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarClienteListItemModel
  {
    public Guid ClienteId { get; set; }
    public string Nombre { get; set; }
    public string PrimerApellido { get; set; }
    public string SegundoApellido { get; set; }
    public string Observaciones { get; set; }
    public string Telefonos { get; set; }
    public string CorreoElectronico { get; set; }
    public string Direccion { get; set; }
  }

  #endregion
}
