﻿using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarCliente
{
  public partial class FormBuscarCliente : BindableFormBase
  {
    #region Atributos

    private readonly BuscarClientePresenter _buscarClientePresenter;

    #endregion

    #region Constructores

    public FormBuscarCliente(BuscarClientePresenter buscarClientePresenter)
    {
      InitializeComponent();
      _buscarClientePresenter = buscarClientePresenter;
    }

    #endregion

    #region Manejadores de eventos

    private void simpleButtonAsignarCliente_Click(object sender, System.EventArgs e)
    {
      var clienteSeleccionado = gridViewListaClientes.GetFocusedRow() as BuscarClienteListItemModel;
      if (clienteSeleccionado != null)
        _buscarClientePresenter.ClienteSeleccionado(clienteSeleccionado);
      Close();
    }

    private void gridViewListaClientes_DoubleClick(object sender, System.EventArgs e)
    {
      simpleButtonAsignarCliente_Click(sender, e);
    }

    private void simpleButtonNuevoCliente_Click(object sender, System.EventArgs e)
    {
      _buscarClientePresenter.MostrarFormCliente();
      Close();
    }

    private void simpleButtonCerrar_Click(object sender, System.EventArgs e)
    {
      Close();
    }

    private void FormBuscarCliente_Load(object sender, System.EventArgs e)
    {
      if (_buscarClientePresenter != null)
      {
        _buscarClientePresenter.SubscribirAccionesACambiosEnElModelo();
        bindingSourcePresenter.DataSource = _buscarClientePresenter;
      }
    }
    #endregion
  }
}