﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarManoDeObra
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar manos de obra
  /// </summary>
  public class BuscarManoDeObraViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarManoDeObraListItemModel> _listaBuscarManosDeObra = new BindingList<BuscarManoDeObraListItemModel>();
    
    #endregion

    #region Propiedades

    public BindingList<BuscarManoDeObraListItemModel> ListaBuscarManosDeObra
    {
      get { return _listaBuscarManosDeObra; }
      set { _listaBuscarManosDeObra = value; }
    }

    public virtual string Descripcion { get; set; }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarManoDeObraListItemModel
  {
    public Guid ManoDeObraId { get; set; }
    public string Descripcion { get; set; }
    public decimal? Duracion { get; set; }
    public decimal? PrecioPorHora { get; set; }
  }

  #endregion
}
