﻿using GestionConcesionarios.Presentacion.Base;
using GestionConcesionarios.Presentacion.CasosDeUso.ManosDeObra;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarManoDeObra
{
  public partial class FormManosDeObra : BindableFormBase
  {
    #region Atributos

    private readonly BuscarManoDeObraPresenter _buscarManoDeObraPresenter;

    #endregion

    #region Constructores

    public FormManosDeObra(BuscarManoDeObraPresenter buscarManoDeObraPresenter)
    {
      InitializeComponent();
      _buscarManoDeObraPresenter = buscarManoDeObraPresenter;
    }

    #endregion

    #region Manejadores de eventos
    
    private void barButtonItemCerrar_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      Close();
    }

    private void gridViewListaManosDeObra_DoubleClick(object sender, System.EventArgs e)
    {
      var manoDeObraSeleccionada = gridViewListaManosDeObra.GetFocusedRow() as BuscarManoDeObraListItemModel;
      if (manoDeObraSeleccionada != null) _buscarManoDeObraPresenter.AsignarManoDeObra(manoDeObraSeleccionada);
      Close();
    }

    private void barButtonItemAsignarManoDeObra_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      gridViewListaManosDeObra_DoubleClick(sender, e);
    }

    private void barButtonItemNuevaManoDeObra_ItemClick(object sender, DevExpress.XtraBars.ItemClickEventArgs e)
    {
      _buscarManoDeObraPresenter.MostrarFormManoDeObra();
      Close();
    }

    private void simpleButtonBuscar_Click(object sender, System.EventArgs e)
    {
      _buscarManoDeObraPresenter.Buscar();
    }

    private void FormManosDeObra_Load(object sender, System.EventArgs e)
    {
      if (_buscarManoDeObraPresenter != null)
      {
        //_buscarManoDeObraPresenter.NuevaBusqueda();
        //_buscarManoDeObraPresenter.SubscribirAccionesACambiosEnElModelo();
        bindingSourcePresenter.DataSource = _buscarManoDeObraPresenter;
      }
    }
    #endregion
  }
}