﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarOrdenDeReparacion
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar órdenes de reparación
  /// </summary>
  public class BuscarOrdenDeReparacionViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarOrdenDeReparacionListItemModel> _listaBuscarOrdenesDeReparacion = new BindingList<BuscarOrdenDeReparacionListItemModel>();

    #endregion
    
    #region Propiedades

    public BindingList<BuscarOrdenDeReparacionListItemModel> ListaBuscarOrdenesDeReparacion
    {
      get { return _listaBuscarOrdenesDeReparacion; }
      set { _listaBuscarOrdenesDeReparacion = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarOrdenDeReparacionListItemModel
  {
    public Guid OrdenDeReparacionId { get; set; }
    public string NumeroOrden { get; set; }
    public Guid? IdCliente { get; set; }
    public string Cliente { get; set; }
    public string Matricula { get; set; }
    public string Estado { get; set; }
    public DateTime? FechaHoraRecepcion { get; set; }
    public DateTime? FechaHoraEntrega { get; set; }
  }

  public class CriteriosBusquedaOrdenDeReparacion
  {
    public string Matricula { get; set; }
    public string NumeroOrden { get; set; }
    public string NombreCliente { get; set; }

    public bool HayMatricula
    {
      get { return !string.IsNullOrWhiteSpace(Matricula); }
    }

    public bool HayNumeroOrden
    {
      get { return !string.IsNullOrWhiteSpace(NumeroOrden); }
    }
  }

  #endregion
}
