﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarPaqueteDeServicio
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar paquetes de servicio
  /// </summary>
  public class BuscarPaqueteDeServicioViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarPaqueteDeServicioListItemModel> _listaBuscarPaquetesDeServicio = new BindingList<BuscarPaqueteDeServicioListItemModel>();
    
    #endregion

    #region Propiedades

    public BindingList<BuscarPaqueteDeServicioListItemModel> ListaBuscarPaquetesDeServicio
    {
      get { return _listaBuscarPaquetesDeServicio; }
      set { _listaBuscarPaquetesDeServicio = value; }
    }

    public virtual string Descripcion { get; set; }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarPaqueteDeServicioListItemModel
  {
    public Guid PaqueteDeServicioId { get; set; }
    public string Descripcion { get; set; }
    public decimal Precio { get; set; }
    public bool Seleccionar { get; set; }
    public decimal? DuracionSugerida { get; set; }
  }

  #endregion
}
