﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarPresupuesto
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar presupuestos
  /// </summary>
  public class BuscarPresupuestoViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarPresupuestoListItemModel> _listaBuscarPresupuestos = new BindingList<BuscarPresupuestoListItemModel>();

    #endregion

    #region Propiedades

    public BindingList<BuscarPresupuestoListItemModel> ListaBuscarPresupuestos
    {
      get { return _listaBuscarPresupuestos; }
      set { _listaBuscarPresupuestos = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarPresupuestoListItemModel
  {
    public Guid PresupuestoId { get; set; }
    public DateTime? Fecha { get; set; }
    public string Cliente { get; set; }
    public string Empleado { get; set; }
    public string NumeroPresupuesto { get; set; }
    public decimal? Subtotal { get; set; }
    public decimal? ImporteIva { get; set; }
    public decimal? ImporteTotal { get; set; }
  }

  public class CriteriosBusquedaPresupuesto
  {
    public string Numero { get; set; }
    public Guid? Cliente { get; set; }
    public DateTime? Fecha { get; set; }
  }

  #endregion
}
