﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarProveedor
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar proveedores
  /// </summary>
  public class BuscarProveedorViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarProveedorListItemModel> _listaBuscarProveedores = new BindingList<BuscarProveedorListItemModel>();

    #endregion
    
    #region Propiedades

    public BindingList<BuscarProveedorListItemModel> ListaBuscarProveedores
    {
      get { return _listaBuscarProveedores; }
      set { _listaBuscarProveedores = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarProveedorListItemModel
  {
    public Guid ProveedorId { get; set; }
    public string Codigo { get; set; }
    public string RazonSocial { get; set; }
    public string CifDni { get; set; }
  }

  public class CriteriosBusquedaProveedor
  {
    public string Codigo { get; set; }
    public string RazonSocial { get; set; }
    public string CifDni { get; set; }

    public bool HayCodigo
    {
      get { return !string.IsNullOrWhiteSpace(Codigo); }
    }

    public bool HayCifDni
    {
      get { return !string.IsNullOrWhiteSpace(CifDni); }
    }
  }

  #endregion
}
