﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarRecepcionVehiculo
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar recepciones vehículos
  /// </summary>
  public class BuscarRecepcionVehiculoViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarRecepcionVehiculoListItemModel> _listaBuscarRecepcionVehiculos = new BindingList<BuscarRecepcionVehiculoListItemModel>();

    #endregion
    
    #region Propiedades

    public BindingList<BuscarRecepcionVehiculoListItemModel> ListaBuscarRecepcionVehiculos
    {
      get { return _listaBuscarRecepcionVehiculos; }
      set { _listaBuscarRecepcionVehiculos = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarRecepcionVehiculoListItemModel
  {
    public Guid RecepcionVehiculoId { get; set; }
    public Guid? IdCliente { get; set; }
    public string Cliente { get; set; }
    public string Matricula { get; set; }
    public string Marca { get; set; }
    public string Modelo { get; set; }
    public string Color { get; set; }
    public DateTime? Fecha { get; set; }
  }

  public class CriteriosBusquedaRecepcionVehiculo
  {
    public string Matricula { get; set; }
    public string NifCif { get; set; }
    public string NombreCliente { get; set; }

    public bool HayMatricula
    {
      get { return !string.IsNullOrWhiteSpace(Matricula); }
    }

    public bool HayNifCif
    {
      get { return !string.IsNullOrWhiteSpace(NifCif); }
    }
  }

  #endregion
}
