﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarReparaciones
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar reparaciones
  /// </summary>
  public class BuscarReparacionViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarReparacionListItemModel> _listaBuscarReparaciones = new BindingList<BuscarReparacionListItemModel>();

    #endregion

    #region Propiedades

    public BindingList<BuscarReparacionListItemModel> ListaBuscarReparaciones
    {
      get { return _listaBuscarReparaciones; }
      set { _listaBuscarReparaciones = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarReparacionListItemModel
  {
    public Guid OrdenDeReparacionId { get; set; }
    public string NumeroOrden { get; set; }
    public DateTime? FechaHoraRecepcion { get; set; }
    public DateTime? FechaHoraEntrega { get; set; }
    public string Estado { get; set; }
    public Guid? IdCliente { get; set; }
    public string Cliente { get; set; }
    public string Matricula { get; set; }
  }

  public class CriteriosBusquedaReparacion
  {
    public string Matricula { get; set; }
    public Guid IdOrdenDeReparacion { get; set; }
    public Guid? IdEmpleado { get; set; }

    public bool HayMatricula
    {
      get { return !string.IsNullOrWhiteSpace(Matricula); }
    }

    public bool HayOrdenDeReparacion
    {
      get { return IdOrdenDeReparacion != Guid.Empty; }
    }
  }

  #endregion
}
