﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarVehiculo
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar vehículos
  /// </summary>
  public class BuscarVehiculoViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarVehiculoListItemModel> _listaBuscarVehiculos = new BindingList<BuscarVehiculoListItemModel>();

    #endregion
    
    #region Propiedades

    public BindingList<BuscarVehiculoListItemModel> ListaBuscarVehiculos
    {
      get { return _listaBuscarVehiculos; }
      set { _listaBuscarVehiculos = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarVehiculoListItemModel
  {
    public Guid VehiculoId { get; set; }
    public string Matricula { get; set; }
    public string Marca { get; set; }
    public string Modelo { get; set; }
    public string Color { get; set; }
    public DateTime? Año { get; set; }
  }

  public class CriteriosBusquedaVehiculo
  {
    public string Matricula { get; set; }
    public string Marca { get; set; }
    public string Modelo { get; set; }
  }

  #endregion
}
