﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarVehiculoVenta
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar vehículos de venta
  /// </summary>
  public class BuscarVehiculoVentaViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarVehiculoVentaListItemModel> _listaBuscarVehiculosVenta = new BindingList<BuscarVehiculoVentaListItemModel>();

    #endregion

    #region Propiedades

    public BindingList<BuscarVehiculoVentaListItemModel> ListaBuscarVehiculosVenta
    {
      get { return _listaBuscarVehiculosVenta; }
      set { _listaBuscarVehiculosVenta = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarVehiculoVentaListItemModel
  {
    public Guid VehiculoId { get; set; }
    public string Matricula { get; set; }
    public string Marca { get; set; }
    public string Modelo { get; set; }
    public string Color { get; set; }
    public DateTime? Año { get; set; }
  }

  public class CriteriosBusquedaVehiculoVenta
  {
    public string Matricula { get; set; }
    public string Marca { get; set; }
    public string Modelo { get; set; }
  }

  #endregion
}
