﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.BuscarVenta
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de buscar facturas
  /// </summary>
  public class BuscarFacturaViewModel : ModelBase
  {
    #region Atributos

    private BindingList<BuscarFacturaListItemModel> _listaBuscarFacturas = new BindingList<BuscarFacturaListItemModel>();

    #endregion

    #region Propiedades

    public BindingList<BuscarFacturaListItemModel> ListaBuscarFacturas
    {
      get { return _listaBuscarFacturas; }
      set { _listaBuscarFacturas = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class BuscarFacturaListItemModel
  {
    public Guid FacturaId { get; set; }
    public DateTime? Fecha { get; set; }
    public string Cliente { get; set; }
    public string Empleado { get; set; }
    public string NumeroFactura { get; set; }
    public decimal? Subtotal { get; set; }
    public decimal? ImporteIva { get; set; }
    public decimal? ImporteTotal { get; set; }
  }

  public class CriteriosBusquedaFactura
  {
    public string Numero { get; set; }
    public Guid? Cliente { get; set; }
    public DateTime? Fecha { get; set; }
  }

  #endregion
}
