﻿using System;
using System.ComponentModel;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.HistorialOrdenesDeReparacion
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista de historial órdenes de reparación
  /// </summary>
  public class HistorialOrdenesDeReparacionViewModel : ModelBase
  {
    #region Atributos

    private BindingList<HistorialOrdenesDeReparacionListItemModel> _listaHistorialOrdenesDeReparacion = new BindingList<HistorialOrdenesDeReparacionListItemModel>();

    #endregion
    
    #region Propiedades

    public BindingList<HistorialOrdenesDeReparacionListItemModel> ListaHistorialOrdenesDeReparacion
    {
      get { return _listaHistorialOrdenesDeReparacion; }
      set { _listaHistorialOrdenesDeReparacion = value; }
    }

    #endregion
  }

  #region Clases Auxiliares

  public class HistorialOrdenesDeReparacionListItemModel
  {
    public Guid OrdenDeReparacionId { get; set; }
    public string Taller { get; set; }
    public DateTime? Fecha { get; set; }
    public string Prediagnostico { get; set; }
    public string ObservacionesDelCliente { get; set; }
    public string Estado { get; set; }
    public string Responsable { get; set; }
  }

  public class CriteriosBusquedaOrdenDeReparacion
  {
    public string Matricula { get; set; }
  }

  #endregion
}
