﻿using System;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.ManosDeObra
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista del vehículo
  /// </summary>
  public class ManoDeObraViewModel : ModelBase, IPersistentModel
  {
    #region Propiedades

    public virtual Guid Id { get; set; }
    public virtual string Descripcion { get; set; }
    public virtual decimal? Duracion { get; set; }
    public virtual decimal? PrecioPorHora { get; set; }
    
    #endregion

    #region Métodos Publicos

    /// <summary>
    /// Determina si el modelo [ha estado persistido].
    /// </summary>
    /// <returns>
    ///   <c>true</c> Si [ha estado persistido]; de otra forma, <c>false</c>.
    /// </returns>
    public bool HasBeenPersisted()
    {
      return !Id.Equals(Guid.Empty);
    }
    #endregion
  }
}
