﻿using FluentValidation;

namespace GestionConcesionarios.Presentacion.CasosDeUso.ManosDeObra
{
  /// <summary>
  /// Para definir un conjunto de reglas de validación para un objeto en particular, hay que 
  /// crear una clase que herede de AbstractValidator <T/>, donde T es el tipo de
  /// Clase que se desea validar.
  /// Para mas información ir a http://fluentvalidation.codeplex.com/documentation
  /// </summary>
  public class ManoDeObraViewModelValidator : AbstractValidator<ManoDeObraViewModel>
  {
    /// <summary>
    /// Inicializa una nueva instancia de la clase<see cref="ManoDeObraViewModelValidator" />.
    /// Configurando las reglas de validación a cumplir.
    /// </summary>
    public ManoDeObraViewModelValidator()
    {
      RuleFor(t => t.Descripcion).NotEmpty();
      RuleFor(t => t.Duracion).GreaterThan(0);
      RuleFor(t => t.PrecioPorHora).GreaterThan(0);
    }
  }
}
