﻿using FluentValidation;

namespace GestionConcesionarios.Presentacion.CasosDeUso.OrdenesDeReparacion
{
  /// <summary>
  /// Para definir un conjunto de reglas de validación para un objeto en particular, hay que 
  /// crear una clase que herede de AbstractValidator <T/>, donde T es el tipo de
  /// Clase que se desea validar.
  /// Para mas información ir a http://fluentvalidation.codeplex.com/documentation
  /// </summary>
  public class OrdenDeReparacionViewModelValidator : AbstractValidator<OrdenDeReparacionViewModel>
  {
    /// <summary>
    /// Inicializa una nueva instancia de la clase<see cref="OrdenDeReparacionViewModelValidator" />.
    /// Configurando las reglas de validación a cumplir.
    /// </summary>
    public OrdenDeReparacionViewModelValidator()
    {
      RuleFor(t => t.NumeroOrden).NotEmpty();
      RuleFor(t => t.FechaEntrega).NotEmpty();
      RuleFor(t => t.HoraEntrega).NotEmpty();
      RuleFor(t => t.IdPersonalAsignado).NotNull().NotEmpty();
      RuleFor(t => t.Diagnostico).NotEmpty();
    }
  }
}
