﻿using FluentValidation;

namespace GestionConcesionarios.Presentacion.CasosDeUso.PaquetesDeServicio
{
  /// <summary>
  /// Para definir un conjunto de reglas de validación para un objeto en particular, hay que 
  /// crear una clase que herede de AbstractValidator <T/>, donde T es el tipo de
  /// Clase que se desea validar.
  /// Para mas información ir a http://fluentvalidation.codeplex.com/documentation
  /// </summary>
  public class PaqueteDeServicioViewModelValidator : AbstractValidator<PaqueteDeServicioViewModel>
  {
    /// <summary>
    /// Inicializa una nueva instancia de la clase<see cref="PaqueteDeServicioViewModelValidator" />.
    /// Configurando las reglas de validación a cumplir.
    /// </summary>
    public PaqueteDeServicioViewModelValidator()
    {
      RuleFor(t => t.Descripcion).NotEmpty();
    }
  }
}
