﻿using FluentValidation;

namespace GestionConcesionarios.Presentacion.CasosDeUso.Presupuestos
{
  /// <summary>
  /// Para definir un conjunto de reglas de validación para un objeto en particular, hay que 
  /// crear una clase que herede de AbstractValidator <T/>, donde T es el tipo de
  /// Clase que se desea validar.
  /// Para mas información ir a http://fluentvalidation.codeplex.com/documentation
  /// </summary>
  public class PresupuestoViewModelValidator : AbstractValidator<PresupuestoViewModel>
  {
    /// <summary>
    /// Inicializa una nueva instancia de la clase<see cref="PresupuestoViewModelValidator" />.
    /// Configurando las reglas de validación a cumplir.
    /// </summary>
    public PresupuestoViewModelValidator()
    {
      RuleFor(t => t.Numero).NotEmpty();
      RuleFor(t => t.IdCliente).NotEmpty();
      RuleFor(t => t.NombreCliente).NotEmpty();
      RuleFor(t => t.IdEmpleado).NotNull().NotEmpty();
    }
  }
}
