﻿using System;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.Proveedores
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista del vehículo
  /// </summary>
  public class ProveedorViewModel : ModelBase, IPersistentModel
  {
    #region Propiedades

    public virtual Guid Id { get; set; }
    public virtual string Codigo { get; set; }
    public virtual string RazonSocial { get; set; }
    public virtual string Direccion { get; set; }
    public virtual int? IdCodigoPostal { get; set; }
    public virtual string CodigoPostal { get; set; }
    public virtual string IdProvincia { get; set; }
    public virtual int? IdPoblacion { get; set; }
    public virtual string CifDni { get; set; }
    public virtual string Observaciones { get; set; }
    public virtual string Telefonos { get; set; }
    public virtual string PaginaWeb { get; set; }
    public virtual string CorreoElectronico { get; set; }

    #endregion

    #region Métodos Publicos

    /// <summary>
    /// Determina si el modelo [ha estado persistido].
    /// </summary>
    /// <returns>
    ///   <c>true</c> Si [ha estado persistido]; de otra forma, <c>false</c>.
    /// </returns>
    public bool HasBeenPersisted()
    {
      return !Id.Equals(Guid.Empty);
    }
    #endregion
  }
}
