﻿using System;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.Vehiculos
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista del vehículo
  /// </summary>
  public class VehiculoViewModel : ModelBase, IPersistentModel
  {
    #region Propiedades

    public virtual Guid Id { get; set; }
    public virtual string Matricula { get; set; }
    public virtual string Marca { get; set; }
    public virtual string Modelo { get; set; }
    public virtual string Bastidor { get; set; }
    public virtual DateTime? Año { get; set; }
    public virtual string Color { get; set; }

    #endregion

    #region Métodos Publicos

    /// <summary>
    /// Determina si el modelo [ha estado persistido].
    /// </summary>
    /// <returns>
    ///   <c>true</c> Si [ha estado persistido]; de otra forma, <c>false</c>.
    /// </returns>
    public bool HasBeenPersisted()
    {
      return !Id.Equals(Guid.Empty);
    }
    #endregion
  }
}
