﻿using FluentValidation;

namespace GestionConcesionarios.Presentacion.CasosDeUso.Vehiculos
{
  /// <summary>
  /// Para definir un conjunto de reglas de validación para un objeto en particular, hay que 
  /// crear una clase que herede de AbstractValidator <T/>, donde T es el tipo de
  /// Clase que se desea validar.
  /// Para mas información ir a http://fluentvalidation.codeplex.com/documentation
  /// </summary>
  public class VehiculoViewModelValidator : AbstractValidator<VehiculoViewModel>
  {
    /// <summary>
    /// Inicializa una nueva instancia de la clase<see cref="VehiculoViewModelValidator" />.
    /// Configurando las reglas de validación a cumplir.
    /// </summary>
    public VehiculoViewModelValidator()
    {
      RuleFor(t => t.Marca).NotEmpty();
      RuleFor(t => t.Modelo).NotEmpty();
      RuleFor(t => t.Matricula).NotEmpty();
    }
  }
}
