﻿using System;
using GestionConcesionarios.Presentacion.Base;

namespace GestionConcesionarios.Presentacion.CasosDeUso.VehiculosDeVenta
{
  /// <summary>
  /// Clase que representa la información a mostrar en la vista del vehículo de venta
  /// </summary>
  public class VehiculoVentaViewModel : ModelBase, IPersistentModel
  {
    #region Propiedades

    public virtual Guid Id { get; set; }
    public virtual string Codigo { get; set; }
    public virtual DateTime? FechaDeEntrada { get; set; }
    public virtual int? Estado { get; set; }
    public virtual string Matricula { get; set; }
    public virtual string Marca { get; set; }
    public virtual string Modelo { get; set; }
    public virtual decimal? Kilometros { get; set; }
    public virtual string Bastidor { get; set; }
    public virtual string Color { get; set; }
    public virtual string Tipo { get; set; }
    public virtual DateTime? FechaMatriculacion { get; set; }
    public virtual decimal? Cilindrada { get; set; }
    public virtual decimal? Potencia { get; set; }
    public virtual string Combustible { get; set; }
    public virtual int? Itv { get; set; }
    public virtual DateTime? UltimaInspeccion { get; set; }
    public virtual DateTime? ProximaInspeccion { get; set; }
    public virtual string Observaciones { get; set; }
    public virtual decimal? Precio { get; set; }
    public virtual DateTime? FechaInicioGarantia { get; set; }
    public virtual int? MesesGarantia { get; set; }
    public virtual DateTime? FechaFinGarantia { get; set; }
    public virtual string CodigoTaller { get; set; }

    public virtual Guid? IdVenta { get; set; }
    public virtual string VendidoPor { get; set; }
    public virtual string NumeroFactura { get; set; }
    public virtual DateTime? FechaVenta { get; set; }

    #endregion

    #region Métodos Publicos

    /// <summary>
    /// Determina si el modelo [ha estado persistido].
    /// </summary>
    /// <returns>
    ///   <c>true</c> Si [ha estado persistido]; de otra forma, <c>false</c>.
    /// </returns>
    public bool HasBeenPersisted()
    {
      return !Id.Equals(Guid.Empty);
    }
    #endregion
  }
}
