﻿using FluentValidation;
using GestionConcesionarios.Presentacion.CasosDeUso.Presupuestos;

namespace GestionConcesionarios.Presentacion.CasosDeUso.Ventas
{
  /// <summary>
  /// Para definir un conjunto de reglas de validación para un objeto en particular, hay que 
  /// crear una clase que herede de AbstractValidator <T/>, donde T es el tipo de
  /// Clase que se desea validar.
  /// Para mas información ir a http://fluentvalidation.codeplex.com/documentation
  /// </summary>
  public class FacturaViewModelValidator : AbstractValidator<FacturaViewModel>
  {
    /// <summary>
    /// Inicializa una nueva instancia de la clase<see cref="FacturaViewModelValidator" />.
    /// Configurando las reglas de validación a cumplir.
    /// </summary>
    public FacturaViewModelValidator()
    {
      RuleFor(t => t.Numero).NotEmpty();
      RuleFor(t => t.IdCliente).NotEmpty();
      RuleFor(t => t.NombreCliente).NotEmpty();
      RuleFor(t => t.IdEmpleado).NotNull().NotEmpty();
    }
  }
}
