﻿using System;
using System.Windows.Forms;
using DevExpress.Utils;
using DevExpress.XtraBars;
using DevExpress.XtraEditors;

namespace GestionConcesionarios.Presentacion.Extensiones
{
  public static class DevExpressExtensions
  {
    public static void AddSuperTip(this SimpleButton button, string title, string text)
    {
      if (button == null) throw new ArgumentNullException("button");
      if (title == null) throw new ArgumentNullException("title");
      if (text == null) throw new ArgumentNullException("text");
      button.SuperTip = new SuperToolTip();
      button.SuperTip.Items.Clear();
      button.SuperTip.Items.AddTitle(title);
      button.SuperTip.Items.Add(text);
    }

    public static void AddSuperTip(this BarButtonItem buttonItem, string title, string text)
    {
      if (buttonItem == null) throw new ArgumentNullException("buttonItem");
      if (title == null) throw new ArgumentNullException("title");
      if (text == null) throw new ArgumentNullException("text");

      buttonItem.SuperTip = new SuperToolTip();
      buttonItem.SuperTip.Items.Clear();
      buttonItem.SuperTip.Items.AddTitle(title);
      buttonItem.SuperTip.Items.Add(text);
    }

    public static void AddSuperTip(this BarCheckItem barCheckItem, string title, string text)
    {
      if (barCheckItem == null) throw new ArgumentNullException("barCheckItem");
      if (title == null) throw new ArgumentNullException("title");
      if (text == null) throw new ArgumentNullException("text");

      barCheckItem.SuperTip = new SuperToolTip();
      barCheckItem.SuperTip.Items.Clear();
      barCheckItem.SuperTip.Items.AddTitle(title);
      barCheckItem.SuperTip.Items.Add(text);
    }

    public static void AddSuperTip(this BarEditItem barEditItem, string title, string text)
    {
      if (barEditItem == null) throw new ArgumentNullException("barEditItem");
      if (title == null) throw new ArgumentNullException("title");
      if (text == null) throw new ArgumentNullException("text");

      barEditItem.SuperTip = new SuperToolTip();
      barEditItem.SuperTip.Items.Clear();
      barEditItem.SuperTip.Items.AddTitle(title);
      barEditItem.SuperTip.Items.Add(text);
    }

    public static void AddControlToPanelWithDockStyleFill(this PanelControl panel, Control control)
    {
      if (panel == null) throw new ArgumentNullException("panel");
      if (control == null) return;
      panel.Controls.Add(control);
      control.Dock = DockStyle.Fill;
    }
  }
}
