﻿using System;
using System.Reflection;
using Autofac;

namespace GestionConcesionarios.Presentacion.Infraestructura.Container
{
  internal static class BuildPresentationModulesHelper
  {
    internal static void Build(ContainerBuilder containerBuilder, Assembly[] presenterAssemblies,
                               string[] namespaces)
    {
      if (containerBuilder == null) throw new ArgumentNullException("containerBuilder");
      if (presenterAssemblies == null) throw new ArgumentNullException("presenterAssemblies");
      if (namespaces == null) throw new ArgumentNullException("namespaces");
      if (presenterAssemblies.Length == 0)
        throw new ArgumentException("no presenterAssemblies to scan", "presenterAssemblies");

      containerBuilder.RegisterModule(new ModelModule(presenterAssemblies, namespaces));
      containerBuilder.RegisterModule(new ViewModule(presenterAssemblies, namespaces));
      containerBuilder.RegisterModule(new PresenterModule(presenterAssemblies, namespaces));
    }
  }
}
