﻿using System;
using Autofac;
using Autofac.Core;
using GestionConcesionarios.Presentacion.Infraestructura.Mediator;

namespace GestionConcesionarios.Presentacion.Infraestructura.Container
{
  public static class ContainerRegisterHelper
  {
    public static void RegisterInMediator(IActivatedEventArgs<object> obj)
    {
      if (obj == null) throw new ArgumentNullException("obj");

      var presenterType = obj.Instance.GetType();

      foreach (RegisterInMediatorAttribute attribute in presenterType.GetCustomAttributes(typeof(RegisterInMediatorAttribute), true))
      {        
        var mediatorToRegisterIn = obj.Context.Resolve<IMediatorManager>();
        mediatorToRegisterIn.Register(obj.Instance);
      }
    }
  }
}
