using System;
using System.Collections.Generic;
using System.DirectoryServices;
using System.DirectoryServices.AccountManagement;
using System.Linq;
using System.Security.Principal;
using Autofac;
using Autofac.Core;
using Carglass.Infrastructure.NHibernate.Extensions;
using Carglass.Infrastructure.NHibernate.UnitOfWork;
using Carglass.Presentation.Base;
using Carglass.Presentation.UseCases.Security.MainForm;
using Carglass.Presentation.UseCases.Security.User;

namespace GestionConcesionarios.Presentacion.Infraestructura.Container
{
  public static class RegisterUserHelper
  {
    public const string SqlOneUser = "SELECT u.Id, u.Name, u.Guid, u.LanguageId, u.CostCenterId, u.Code,c.BusinessUnitId AS BusinessUnitId FROM UsersDirectory u,CostCenters c WHERE u.Guid = :GUID";

    public static void RegisterUser(IActivatedEventArgs<object> obj)
    {
      var mainForm = (MainForm) obj.Instance;
      //coger guid del active directory del usuario que esta
      var id = UserPrincipal.Current;

      if(!IsUserOfActiveDirectory(id.Guid))
      {
        int a;
        a = 1;
        return;
      }
      //mirar en base de datos si tiene el usuario CurrentUserModel
      using (var unitOfWork = mainForm.LifetimeScope.Resolve<IUnitOfWork>())
      {
        var query1 = unitOfWork.Session.CreateQueryWrapper<UserModel>(SqlOneUser);
        query1.SetParameter("GUID", id.Guid.ToString());
        var userModels = query1.Execute();
        // asignar CurrentUserModel al mainform
      }
    }

    public static bool IsUserOfActiveDirectory(Guid? guid)
    {
      if (guid == null)
        return false;

      string guidOctectString = ConvertGuidToOctectString(guid.ToString());
      DirectoryEntry objADAM = default(DirectoryEntry);
      // Binding object. 
      DirectoryEntry objGroupEntry = default(DirectoryEntry);
      // Group Results. 
      DirectorySearcher objSearchADAM = default(DirectorySearcher);
      // Search object. 
      SearchResultCollection objSearchResults = default(SearchResultCollection);
      // Results collection. 
      string strPath = null;
      // Binding path. 

      // Construct the binding string. 
      strPath = "";
      //Change to your ADserver 

      // Get the AD LDS object. 
      try
      {
        objADAM = new DirectoryEntry(strPath);
        objADAM.RefreshCache();
      }
      catch (Exception e)
      {
        throw e;
      }

      // Get search object, specify filter and scope, 
      // perform search. 
      try
      { 
        objSearchADAM = new DirectorySearcher(objADAM);
        objSearchADAM.Filter = string.Format("(&(objectClass=user)(objectGUID={0}))",guidOctectString);
        objSearchADAM.SearchScope = SearchScope.Subtree;
        objSearchResults = objSearchADAM.FindAll();
      }
      catch (Exception e)
      {
        throw e;
      }

      // Enumerate groups 
      try
      {
        if (objSearchResults.Count != 0)
        {
          //foreach (SearchResult objResult in objSearchResults)
          //{
          //  objGroupEntry = objResult.GetDirectoryEntry();
          //  if (objGroupEntry.Guid.ToString().Equals(guid))
          return true;
          //}
        }
        else
        {
          return false;
          throw new Exception("No groups found");
        }
      }
      catch (Exception e)
      {
        throw new Exception(e.Message);
      }

      return false;
    }

    private static string ConvertGuidToOctectString(string objectGuid)
    {
      System.Guid guid = new Guid(objectGuid);
      byte[] byteGuid = guid.ToByteArray();

      string queryGuid = "";

      foreach (byte b in byteGuid)
      {
        queryGuid += @"\" + b.ToString("x2");
      }

      return queryGuid;
    }
  }
}