﻿using Castle.DynamicProxy;

namespace GestionConcesionarios.Presentacion.Infraestructura.Interceptors
{
  public class TargetObjectInterceptor : IInterceptor
  {

    public TargetObjectInterceptor()
    {
    }

    public void Intercept(IInvocation invocation)
    {
      invocation.Proceed();
      if (invocation.Method.Name.StartsWith("GetTarget"))
      {
        var proxyTargetAccessor = invocation.InvocationTarget as IProxyTargetAccessor;
        if (proxyTargetAccessor != null)
          invocation.ReturnValue = proxyTargetAccessor.DynProxyGetTarget();
      }
    }
  }
}