﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using DevExpress.LookAndFeel;

namespace GestionConcesionarios
{
  static class Program
  {
    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main()
    {
      Application.EnableVisualStyles();
      Application.SetCompatibleTextRenderingDefault(false);

      DevExpress.Skins.SkinManager.EnableFormSkins();
      DevExpress.UserSkins.BonusSkins.Register();
      UserLookAndFeel.Default.SetSkinStyle("DevExpress Style");

      var pantallaBienvenida = new PantallaBienvenida();
      pantallaBienvenida.ShowDialog();

      var formLogin = new FormLogin();
      formLogin.ShowDialog();

      Application.Run(new FormPrincipal());
      Environment.Exit(0);
    }
  }
}