//----------------------------------------------------------------------------------------
// AddFlow for WinForms: DrawDrop sample
// Copyright (c) 2003-2011 Lassalle Technologies. All Rights Reserved
// http://www.lassalle.com
// Author: Patrick Lassalle    
// THIS CODE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND EITHER EXPRESSED OR IMPLIED.
//----------------------------------------------------------------------------------------

using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Lassalle.Flow;

namespace DragDrop
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            TreeView1.Dock = DockStyle.Left; 
            TreeView1.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(TreeView1_ItemDrag);
            TreeNode node1 = TreeView1.Nodes.Add("node1");
            TreeNode node2 = TreeView1.Nodes.Add("node2");
            TreeNode node3 = TreeView1.Nodes.Add("node3");

            addFlow1.Dock = DockStyle.Fill;
            addFlow1.BackColor = SystemColors.Window;
            addFlow1.AllowDrop = true;
            addFlow1.CanDragScroll = false;
            addFlow1.AutoScroll = false;
            addFlow1.PageUnit = GraphicsUnit.Point;
            addFlow1.DefNodeProp.FillColor = System.Drawing.Color.Aqua;
            addFlow1.DefNodeProp.Shape.Style = Lassalle.Flow.ShapeStyle.Document; 
            addFlow1.DragEnter += new System.Windows.Forms.DragEventHandler(addFlow1_DragEnter);
            addFlow1.DragDrop += new System.Windows.Forms.DragEventHandler(addFlow1_DragDrop);

        }

        private void ExitMenu_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void AboutMenu_Click(object sender, EventArgs e)
        {
            MessageBox.Show("AddFlow for WinForms: DragDrop sample\r\nCopyright  2003-2011 Lassalle Technologies");
        }

        private void TreeView1_ItemDrag(object sender, ItemDragEventArgs e)
        {
            addFlow1.DoDragDrop(e.Item, DragDropEffects.Move);
        }

        private void addFlow1_DragEnter(object sender, DragEventArgs e)
        {
            TreeNode treenode = (TreeNode)e.Data.GetData("System.Windows.Forms.TreeNode", true);
            if (treenode != null) 
                e.Effect = DragDropEffects.Move;
        }

        private void addFlow1_DragDrop(object sender, DragEventArgs e)
        {
            TreeNode treenode = (TreeNode)e.Data.GetData("System.Windows.Forms.TreeNode", true);
            if (treenode != null)
            {
                Point ptClient = addFlow1.PointToClient(new Point(e.X, e.Y));
                Point ptAddFlow = addFlow1.PointToAddFlow(ptClient);
                Node node = addFlow1.Nodes.Add(ptAddFlow.X, ptAddFlow.Y, 40, 40);
                node.Text = treenode.Text;
            }
        }
    }
}