using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RouteLink
{
    public partial class RouteParameters : Form
    {
        float m_grain = 8;
        float m_minDistance = 16;
        Lassalle.Flow.Router.StartingMethod m_startingMethod = Lassalle.Flow.Router.StartingMethod.AllSides;
        bool m_sendStepEvent = false;

        public RouteParameters()
        {
            InitializeComponent();
        }

        private void RouteParameters_Load(object sender, EventArgs e)
        {       
            foreach (Lassalle.Flow.Router.StartingMethod sm in System.Enum.GetValues(m_startingMethod.GetType()))
                comboBoxStartingMethod.Items.Add(sm.ToString());
            comboBoxStartingMethod.SelectedIndex = (int)m_startingMethod;
            CheckBoxSendStepEvent.Checked = m_sendStepEvent;
            TextBoxGrain.Text = m_grain.ToString();
            TextBoxMinDistance.Text = m_minDistance.ToString();
        }
        
        public bool SendStepEvent
        {
            get { return m_sendStepEvent; }
            set {m_sendStepEvent = value; }
        }

        public float Grain
        {
            get { return m_grain; }
            set {m_grain = value; }
        }

        public float MinDistance
        {
            get { return m_minDistance; }
            set {m_minDistance = value; }
        }

        public Lassalle.Flow.Router.StartingMethod StartingMethod
        {
            get { return m_startingMethod; }
            set {m_startingMethod = value; }
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            m_sendStepEvent = CheckBoxSendStepEvent.Checked;
            m_startingMethod = (Lassalle.Flow.Router.StartingMethod)comboBoxStartingMethod.SelectedIndex;
            m_grain = Convert.ToInt32(TextBoxGrain.Text);
            m_minDistance = Convert.ToInt32(TextBoxMinDistance.Text);
        }
    }
}