using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Lassalle.Flow;

namespace Lassalle.DlgFlow
{
	/// <summary>
	/// Summary description for Arrow.
	/// </summary>
	internal class ArrowDlg : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button button2;
        private System.Windows.Forms.Button button1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.ComboBox comboBoxSize;
        private System.Windows.Forms.ComboBox comboBoxStyle;
        private System.Windows.Forms.ComboBox comboBoxAngle;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.CheckBox checkBoxFilled;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        private Arrow m_arrow = null;

		public ArrowDlg()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button2 = new System.Windows.Forms.Button();
            this.button1 = new System.Windows.Forms.Button();
            this.comboBoxSize = new System.Windows.Forms.ComboBox();
            this.comboBoxStyle = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.comboBoxAngle = new System.Windows.Forms.ComboBox();
            this.label3 = new System.Windows.Forms.Label();
            this.checkBoxFilled = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            // 
            // button2
            // 
            this.button2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.button2.Location = new System.Drawing.Point(288, 240);
            this.button2.Name = "button2";
            this.button2.TabIndex = 4;
            this.button2.Text = "Cancel";
            // 
            // button1
            // 
            this.button1.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.button1.Location = new System.Drawing.Point(200, 240);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(80, 24);
            this.button1.TabIndex = 3;
            this.button1.Text = "OK";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // comboBoxSize
            // 
            this.comboBoxSize.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxSize.Location = new System.Drawing.Point(24, 88);
            this.comboBoxSize.Name = "comboBoxSize";
            this.comboBoxSize.Size = new System.Drawing.Size(104, 21);
            this.comboBoxSize.TabIndex = 17;
            // 
            // comboBoxStyle
            // 
            this.comboBoxStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxStyle.Location = new System.Drawing.Point(24, 32);
            this.comboBoxStyle.Name = "comboBoxStyle";
            this.comboBoxStyle.Size = new System.Drawing.Size(104, 21);
            this.comboBoxStyle.TabIndex = 16;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(24, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(29, 13);
            this.label1.TabIndex = 18;
            this.label1.Text = "Style";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(24, 72);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(26, 13);
            this.label2.TabIndex = 19;
            this.label2.Text = "Size";
            // 
            // comboBoxAngle
            // 
            this.comboBoxAngle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxAngle.Location = new System.Drawing.Point(24, 144);
            this.comboBoxAngle.Name = "comboBoxAngle";
            this.comboBoxAngle.Size = new System.Drawing.Size(104, 21);
            this.comboBoxAngle.TabIndex = 20;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(24, 128);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(33, 13);
            this.label3.TabIndex = 21;
            this.label3.Text = "Angle";
            // 
            // checkBoxFilled
            // 
            this.checkBoxFilled.Location = new System.Drawing.Point(24, 192);
            this.checkBoxFilled.Name = "checkBoxFilled";
            this.checkBoxFilled.Size = new System.Drawing.Size(88, 24);
            this.checkBoxFilled.TabIndex = 22;
            this.checkBoxFilled.Text = "&Filled";
            // 
            // ArrowDlg
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(5, 13);
            this.ClientSize = new System.Drawing.Size(368, 273);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.checkBoxFilled,
                                                                          this.label3,
                                                                          this.comboBoxAngle,
                                                                          this.label2,
                                                                          this.label1,
                                                                          this.comboBoxSize,
                                                                          this.comboBoxStyle,
                                                                          this.button2,
                                                                          this.button1});
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Name = "ArrowDlg";
            this.Text = "Arrow";
            this.Load += new System.EventHandler(this.Arrow_Load);
            this.ResumeLayout(false);

        }
		#endregion
        
        public Arrow Arrow
        {
            get { return m_arrow; }
            set { m_arrow = value; }
        }

        private void Arrow_Load(object sender, System.EventArgs e)
        {            
            foreach (ArrowStyle v in Enum.GetValues(typeof(ArrowStyle)))
                comboBoxStyle.Items.Add(v.ToString());
            comboBoxStyle.SelectedItem = m_arrow.Style.ToString();

            foreach (ArrowSize v in Enum.GetValues(typeof(ArrowSize)))
                comboBoxSize.Items.Add(v.ToString());
            comboBoxSize.SelectedItem = m_arrow.Size.ToString();
            
            foreach (ArrowAngle v in Enum.GetValues(typeof(ArrowAngle)))
                comboBoxAngle.Items.Add(v.ToString());
            comboBoxAngle.SelectedItem = m_arrow.Angle.ToString();
            
            checkBoxFilled.Checked = m_arrow.Filled;
        }

        private void button1_Click(object sender, System.EventArgs e)
        {            
            ArrowStyle style = (ArrowStyle)comboBoxStyle.SelectedIndex;
            ArrowSize size = (ArrowSize)comboBoxSize.SelectedIndex;
            ArrowAngle angle = (ArrowAngle)comboBoxAngle.SelectedIndex;
            bool filled = checkBoxFilled.Checked;
            m_arrow = new Arrow(style, size, angle, filled);
        }
	}
}
