using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Lassalle.Flow;

namespace Lassalle.DlgFlow
{
    /// <summary>
    /// Summary description for nodepp.
    /// </summary>
    internal class LinkPropertyPage : System.Windows.Forms.Form
    {
        private System.Windows.Forms.Button button1;
        private System.Windows.Forms.Button button2;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;
        private System.Windows.Forms.TabPage tabPage1;
        private System.Windows.Forms.ComboBox comboBoxPenWidth;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.ComboBox comboBoxDashStyle;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.TabPage tabPage3;
        private System.Windows.Forms.TabPage tabPage2;
        private System.Windows.Forms.TabPage tabPage4;
        private System.Windows.Forms.TabControl tabControl1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.Label label9;
        private System.Windows.Forms.ComboBox comboBoxLinkStyle;
        private System.Windows.Forms.Label label10;
        private System.Windows.Forms.ComboBox comboBoxJump;
        private System.Windows.Forms.CheckBox checkBoxOrientedText;
        private System.Windows.Forms.CheckBox checkBoxOrthogonalDynamic;
        private System.Windows.Forms.CheckBox checkBoxLogical;
        private System.Windows.Forms.CheckBox checkBoxHidden;
        private System.Windows.Forms.CheckBox checkBoxAdjustDst;
        private System.Windows.Forms.CheckBox checkBoxAdjustOrg;
        private System.Windows.Forms.CheckBox checkBoxRigid;
        private System.Windows.Forms.CheckBox checkBoxSelectable;
        private System.Windows.Forms.CheckBox checkBoxStretchable;
        private System.Windows.Forms.TextBox textBoxText;
        private System.Windows.Forms.Label label13;
        private System.Windows.Forms.CheckBox checkBoxOwnerDraw;
        private System.Windows.Forms.Button buttonTextColor;
        private System.Windows.Forms.Button buttonDrawColor;
        private System.Windows.Forms.Label labelTextColor;
        private System.Windows.Forms.Label labelDrawColor;
        private System.Windows.Forms.TextBox textBoxArrowDst;
        private System.Windows.Forms.TextBox textBoxArrowOrg;
        private System.Windows.Forms.TextBox textBoxArrowMid;
        private System.Windows.Forms.Button buttonArrowDst;
        private System.Windows.Forms.Button buttonArrowOrg;
        private System.Windows.Forms.Button buttonArrowMid;
        private System.Windows.Forms.Button buttonFont;
        private System.Windows.Forms.CheckBox checkBoxRoundedCorner;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.ComboBox comboBoxStartCap;
        private System.Windows.Forms.ComboBox comboBoxEndCap;
        private System.Windows.Forms.Label label7;

        private AddFlow m_addflow = null;
		private System.Windows.Forms.TextBox textBoxTooltip;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.TextBox textBoxUrl;
		private System.Windows.Forms.Label label17;
        private CheckBox checkBoxRemoveChildren;
        private CheckBox checkBoxHighlightChildren;
        private ComboBox comboBoxConnectionStyleDst;
        private Label label11;
        private ComboBox comboBoxConnectionStyleOrg;
        private Label label8;
        private Link m_link = null;

        public LinkPropertyPage()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }        

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if(components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

		#region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.tabPage1 = new System.Windows.Forms.TabPage();
            this.comboBoxConnectionStyleDst = new System.Windows.Forms.ComboBox();
            this.label11 = new System.Windows.Forms.Label();
            this.comboBoxConnectionStyleOrg = new System.Windows.Forms.ComboBox();
            this.label8 = new System.Windows.Forms.Label();
            this.comboBoxEndCap = new System.Windows.Forms.ComboBox();
            this.label7 = new System.Windows.Forms.Label();
            this.comboBoxStartCap = new System.Windows.Forms.ComboBox();
            this.label6 = new System.Windows.Forms.Label();
            this.buttonArrowMid = new System.Windows.Forms.Button();
            this.buttonArrowOrg = new System.Windows.Forms.Button();
            this.buttonArrowDst = new System.Windows.Forms.Button();
            this.textBoxArrowMid = new System.Windows.Forms.TextBox();
            this.textBoxArrowOrg = new System.Windows.Forms.TextBox();
            this.textBoxArrowDst = new System.Windows.Forms.TextBox();
            this.comboBoxJump = new System.Windows.Forms.ComboBox();
            this.label10 = new System.Windows.Forms.Label();
            this.comboBoxLinkStyle = new System.Windows.Forms.ComboBox();
            this.label9 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.comboBoxPenWidth = new System.Windows.Forms.ComboBox();
            this.label3 = new System.Windows.Forms.Label();
            this.comboBoxDashStyle = new System.Windows.Forms.ComboBox();
            this.label2 = new System.Windows.Forms.Label();
            this.tabPage3 = new System.Windows.Forms.TabPage();
            this.checkBoxRemoveChildren = new System.Windows.Forms.CheckBox();
            this.checkBoxHighlightChildren = new System.Windows.Forms.CheckBox();
            this.checkBoxRoundedCorner = new System.Windows.Forms.CheckBox();
            this.checkBoxOwnerDraw = new System.Windows.Forms.CheckBox();
            this.checkBoxStretchable = new System.Windows.Forms.CheckBox();
            this.checkBoxSelectable = new System.Windows.Forms.CheckBox();
            this.checkBoxRigid = new System.Windows.Forms.CheckBox();
            this.checkBoxOrientedText = new System.Windows.Forms.CheckBox();
            this.checkBoxOrthogonalDynamic = new System.Windows.Forms.CheckBox();
            this.checkBoxLogical = new System.Windows.Forms.CheckBox();
            this.checkBoxHidden = new System.Windows.Forms.CheckBox();
            this.checkBoxAdjustDst = new System.Windows.Forms.CheckBox();
            this.checkBoxAdjustOrg = new System.Windows.Forms.CheckBox();
            this.tabPage2 = new System.Windows.Forms.TabPage();
            this.textBoxUrl = new System.Windows.Forms.TextBox();
            this.label17 = new System.Windows.Forms.Label();
            this.textBoxTooltip = new System.Windows.Forms.TextBox();
            this.label16 = new System.Windows.Forms.Label();
            this.buttonFont = new System.Windows.Forms.Button();
            this.textBoxText = new System.Windows.Forms.TextBox();
            this.label13 = new System.Windows.Forms.Label();
            this.tabPage4 = new System.Windows.Forms.TabPage();
            this.buttonTextColor = new System.Windows.Forms.Button();
            this.buttonDrawColor = new System.Windows.Forms.Button();
            this.labelTextColor = new System.Windows.Forms.Label();
            this.labelDrawColor = new System.Windows.Forms.Label();
            this.tabControl1 = new System.Windows.Forms.TabControl();
            this.tabPage1.SuspendLayout();
            this.tabPage3.SuspendLayout();
            this.tabPage2.SuspendLayout();
            this.tabPage4.SuspendLayout();
            this.tabControl1.SuspendLayout();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.button1.Location = new System.Drawing.Point(280, 304);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(80, 24);
            this.button1.TabIndex = 0;
            this.button1.Text = "OK";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.button2.Location = new System.Drawing.Point(368, 304);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(75, 23);
            this.button2.TabIndex = 1;
            this.button2.Text = "Cancel";
            // 
            // tabPage1
            // 
            this.tabPage1.Controls.Add(this.comboBoxConnectionStyleDst);
            this.tabPage1.Controls.Add(this.label11);
            this.tabPage1.Controls.Add(this.comboBoxConnectionStyleOrg);
            this.tabPage1.Controls.Add(this.label8);
            this.tabPage1.Controls.Add(this.comboBoxEndCap);
            this.tabPage1.Controls.Add(this.label7);
            this.tabPage1.Controls.Add(this.comboBoxStartCap);
            this.tabPage1.Controls.Add(this.label6);
            this.tabPage1.Controls.Add(this.buttonArrowMid);
            this.tabPage1.Controls.Add(this.buttonArrowOrg);
            this.tabPage1.Controls.Add(this.buttonArrowDst);
            this.tabPage1.Controls.Add(this.textBoxArrowMid);
            this.tabPage1.Controls.Add(this.textBoxArrowOrg);
            this.tabPage1.Controls.Add(this.textBoxArrowDst);
            this.tabPage1.Controls.Add(this.comboBoxJump);
            this.tabPage1.Controls.Add(this.label10);
            this.tabPage1.Controls.Add(this.comboBoxLinkStyle);
            this.tabPage1.Controls.Add(this.label9);
            this.tabPage1.Controls.Add(this.label5);
            this.tabPage1.Controls.Add(this.label4);
            this.tabPage1.Controls.Add(this.label1);
            this.tabPage1.Controls.Add(this.comboBoxPenWidth);
            this.tabPage1.Controls.Add(this.label3);
            this.tabPage1.Controls.Add(this.comboBoxDashStyle);
            this.tabPage1.Controls.Add(this.label2);
            this.tabPage1.Location = new System.Drawing.Point(4, 22);
            this.tabPage1.Name = "tabPage1";
            this.tabPage1.Size = new System.Drawing.Size(432, 254);
            this.tabPage1.TabIndex = 0;
            this.tabPage1.Text = "Styles";
            // 
            // comboBoxConnectionStyleDst
            // 
            this.comboBoxConnectionStyleDst.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxConnectionStyleDst.Location = new System.Drawing.Point(240, 144);
            this.comboBoxConnectionStyleDst.Name = "comboBoxConnectionStyleDst";
            this.comboBoxConnectionStyleDst.Size = new System.Drawing.Size(160, 21);
            this.comboBoxConnectionStyleDst.TabIndex = 35;
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(240, 128);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(100, 13);
            this.label11.TabIndex = 36;
            this.label11.Text = "ConnectionStyleDst";
            // 
            // comboBoxConnectionStyleOrg
            // 
            this.comboBoxConnectionStyleOrg.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxConnectionStyleOrg.Location = new System.Drawing.Point(240, 106);
            this.comboBoxConnectionStyleOrg.Name = "comboBoxConnectionStyleOrg";
            this.comboBoxConnectionStyleOrg.Size = new System.Drawing.Size(160, 21);
            this.comboBoxConnectionStyleOrg.TabIndex = 33;
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(240, 90);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(101, 13);
            this.label8.TabIndex = 34;
            this.label8.Text = "ConnectionStyleOrg";
            // 
            // comboBoxEndCap
            // 
            this.comboBoxEndCap.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxEndCap.Location = new System.Drawing.Point(240, 24);
            this.comboBoxEndCap.Name = "comboBoxEndCap";
            this.comboBoxEndCap.Size = new System.Drawing.Size(160, 21);
            this.comboBoxEndCap.TabIndex = 10;
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(240, 8);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(45, 13);
            this.label7.TabIndex = 32;
            this.label7.Text = "EndCap";
            // 
            // comboBoxStartCap
            // 
            this.comboBoxStartCap.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxStartCap.Location = new System.Drawing.Point(240, 64);
            this.comboBoxStartCap.Name = "comboBoxStartCap";
            this.comboBoxStartCap.Size = new System.Drawing.Size(160, 21);
            this.comboBoxStartCap.TabIndex = 11;
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(240, 48);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(48, 13);
            this.label6.TabIndex = 30;
            this.label6.Text = "StartCap";
            // 
            // buttonArrowMid
            // 
            this.buttonArrowMid.Location = new System.Drawing.Point(176, 104);
            this.buttonArrowMid.Name = "buttonArrowMid";
            this.buttonArrowMid.Size = new System.Drawing.Size(24, 23);
            this.buttonArrowMid.TabIndex = 5;
            this.buttonArrowMid.Text = "...";
            this.buttonArrowMid.Click += new System.EventHandler(this.buttonArrowMid_Click);
            // 
            // buttonArrowOrg
            // 
            this.buttonArrowOrg.Location = new System.Drawing.Point(176, 64);
            this.buttonArrowOrg.Name = "buttonArrowOrg";
            this.buttonArrowOrg.Size = new System.Drawing.Size(24, 23);
            this.buttonArrowOrg.TabIndex = 3;
            this.buttonArrowOrg.Text = "...";
            this.buttonArrowOrg.Click += new System.EventHandler(this.buttonArrowOrg_Click);
            // 
            // buttonArrowDst
            // 
            this.buttonArrowDst.Location = new System.Drawing.Point(176, 24);
            this.buttonArrowDst.Name = "buttonArrowDst";
            this.buttonArrowDst.Size = new System.Drawing.Size(24, 23);
            this.buttonArrowDst.TabIndex = 1;
            this.buttonArrowDst.Text = "...";
            this.buttonArrowDst.Click += new System.EventHandler(this.buttonArrowDst_Click);
            // 
            // textBoxArrowMid
            // 
            this.textBoxArrowMid.Location = new System.Drawing.Point(8, 104);
            this.textBoxArrowMid.Name = "textBoxArrowMid";
            this.textBoxArrowMid.Size = new System.Drawing.Size(160, 20);
            this.textBoxArrowMid.TabIndex = 4;
            // 
            // textBoxArrowOrg
            // 
            this.textBoxArrowOrg.Location = new System.Drawing.Point(8, 64);
            this.textBoxArrowOrg.Name = "textBoxArrowOrg";
            this.textBoxArrowOrg.Size = new System.Drawing.Size(160, 20);
            this.textBoxArrowOrg.TabIndex = 2;
            // 
            // textBoxArrowDst
            // 
            this.textBoxArrowDst.Location = new System.Drawing.Point(8, 24);
            this.textBoxArrowDst.Name = "textBoxArrowDst";
            this.textBoxArrowDst.Size = new System.Drawing.Size(160, 20);
            this.textBoxArrowDst.TabIndex = 0;
            // 
            // comboBoxJump
            // 
            this.comboBoxJump.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxJump.Location = new System.Drawing.Point(8, 184);
            this.comboBoxJump.Name = "comboBoxJump";
            this.comboBoxJump.Size = new System.Drawing.Size(121, 21);
            this.comboBoxJump.TabIndex = 7;
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(8, 168);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(32, 13);
            this.label10.TabIndex = 20;
            this.label10.Text = "Jump";
            // 
            // comboBoxLinkStyle
            // 
            this.comboBoxLinkStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxLinkStyle.Location = new System.Drawing.Point(8, 144);
            this.comboBoxLinkStyle.Name = "comboBoxLinkStyle";
            this.comboBoxLinkStyle.Size = new System.Drawing.Size(121, 21);
            this.comboBoxLinkStyle.TabIndex = 6;
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(8, 128);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(50, 13);
            this.label9.TabIndex = 18;
            this.label9.Text = "LineStyle";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(8, 88);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(51, 13);
            this.label5.TabIndex = 10;
            this.label5.Text = "ArrowMid";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(8, 48);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(51, 13);
            this.label4.TabIndex = 8;
            this.label4.Text = "ArrowOrg";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(8, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(50, 13);
            this.label1.TabIndex = 6;
            this.label1.Text = "ArrowDst";
            // 
            // comboBoxPenWidth
            // 
            this.comboBoxPenWidth.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxPenWidth.ItemHeight = 13;
            this.comboBoxPenWidth.Location = new System.Drawing.Point(144, 224);
            this.comboBoxPenWidth.Name = "comboBoxPenWidth";
            this.comboBoxPenWidth.Size = new System.Drawing.Size(56, 21);
            this.comboBoxPenWidth.TabIndex = 9;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(144, 208);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(54, 13);
            this.label3.TabIndex = 4;
            this.label3.Text = "PenWidth";
            // 
            // comboBoxDashStyle
            // 
            this.comboBoxDashStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxDashStyle.ItemHeight = 13;
            this.comboBoxDashStyle.Location = new System.Drawing.Point(8, 224);
            this.comboBoxDashStyle.Name = "comboBoxDashStyle";
            this.comboBoxDashStyle.Size = new System.Drawing.Size(104, 21);
            this.comboBoxDashStyle.TabIndex = 8;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(8, 208);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(55, 13);
            this.label2.TabIndex = 2;
            this.label2.Text = "DashStyle";
            // 
            // tabPage3
            // 
            this.tabPage3.Controls.Add(this.checkBoxRemoveChildren);
            this.tabPage3.Controls.Add(this.checkBoxHighlightChildren);
            this.tabPage3.Controls.Add(this.checkBoxRoundedCorner);
            this.tabPage3.Controls.Add(this.checkBoxOwnerDraw);
            this.tabPage3.Controls.Add(this.checkBoxStretchable);
            this.tabPage3.Controls.Add(this.checkBoxSelectable);
            this.tabPage3.Controls.Add(this.checkBoxRigid);
            this.tabPage3.Controls.Add(this.checkBoxOrientedText);
            this.tabPage3.Controls.Add(this.checkBoxOrthogonalDynamic);
            this.tabPage3.Controls.Add(this.checkBoxLogical);
            this.tabPage3.Controls.Add(this.checkBoxHidden);
            this.tabPage3.Controls.Add(this.checkBoxAdjustDst);
            this.tabPage3.Controls.Add(this.checkBoxAdjustOrg);
            this.tabPage3.Location = new System.Drawing.Point(4, 22);
            this.tabPage3.Name = "tabPage3";
            this.tabPage3.Size = new System.Drawing.Size(432, 254);
            this.tabPage3.TabIndex = 2;
            this.tabPage3.Text = "Flags";
            // 
            // checkBoxRemoveChildren
            // 
            this.checkBoxRemoveChildren.Location = new System.Drawing.Point(281, 48);
            this.checkBoxRemoveChildren.Name = "checkBoxRemoveChildren";
            this.checkBoxRemoveChildren.Size = new System.Drawing.Size(120, 24);
            this.checkBoxRemoveChildren.TabIndex = 20;
            this.checkBoxRemoveChildren.Text = "RemoveChildren";
            // 
            // checkBoxHighlightChildren
            // 
            this.checkBoxHighlightChildren.Location = new System.Drawing.Point(281, 16);
            this.checkBoxHighlightChildren.Name = "checkBoxHighlightChildren";
            this.checkBoxHighlightChildren.Size = new System.Drawing.Size(120, 24);
            this.checkBoxHighlightChildren.TabIndex = 19;
            this.checkBoxHighlightChildren.Text = "HighlightChildren";
            // 
            // checkBoxRoundedCorner
            // 
            this.checkBoxRoundedCorner.Location = new System.Drawing.Point(144, 48);
            this.checkBoxRoundedCorner.Name = "checkBoxRoundedCorner";
            this.checkBoxRoundedCorner.Size = new System.Drawing.Size(104, 24);
            this.checkBoxRoundedCorner.TabIndex = 18;
            this.checkBoxRoundedCorner.Text = "RoundedCorner";
            // 
            // checkBoxOwnerDraw
            // 
            this.checkBoxOwnerDraw.Location = new System.Drawing.Point(16, 208);
            this.checkBoxOwnerDraw.Name = "checkBoxOwnerDraw";
            this.checkBoxOwnerDraw.Size = new System.Drawing.Size(128, 24);
            this.checkBoxOwnerDraw.TabIndex = 17;
            this.checkBoxOwnerDraw.Text = "OwnerDraw";
            // 
            // checkBoxStretchable
            // 
            this.checkBoxStretchable.Location = new System.Drawing.Point(144, 112);
            this.checkBoxStretchable.Name = "checkBoxStretchable";
            this.checkBoxStretchable.Size = new System.Drawing.Size(104, 24);
            this.checkBoxStretchable.TabIndex = 8;
            this.checkBoxStretchable.Text = "Stretchable";
            // 
            // checkBoxSelectable
            // 
            this.checkBoxSelectable.Location = new System.Drawing.Point(144, 80);
            this.checkBoxSelectable.Name = "checkBoxSelectable";
            this.checkBoxSelectable.Size = new System.Drawing.Size(104, 24);
            this.checkBoxSelectable.TabIndex = 7;
            this.checkBoxSelectable.Text = "Selectable";
            // 
            // checkBoxRigid
            // 
            this.checkBoxRigid.Location = new System.Drawing.Point(144, 16);
            this.checkBoxRigid.Name = "checkBoxRigid";
            this.checkBoxRigid.Size = new System.Drawing.Size(104, 24);
            this.checkBoxRigid.TabIndex = 6;
            this.checkBoxRigid.Text = "Rigid";
            // 
            // checkBoxOrientedText
            // 
            this.checkBoxOrientedText.Location = new System.Drawing.Point(16, 176);
            this.checkBoxOrientedText.Name = "checkBoxOrientedText";
            this.checkBoxOrientedText.Size = new System.Drawing.Size(128, 24);
            this.checkBoxOrientedText.TabIndex = 5;
            this.checkBoxOrientedText.Text = "OrientedText";
            // 
            // checkBoxOrthogonalDynamic
            // 
            this.checkBoxOrthogonalDynamic.Location = new System.Drawing.Point(16, 144);
            this.checkBoxOrthogonalDynamic.Name = "checkBoxOrthogonalDynamic";
            this.checkBoxOrthogonalDynamic.Size = new System.Drawing.Size(128, 24);
            this.checkBoxOrthogonalDynamic.TabIndex = 4;
            this.checkBoxOrthogonalDynamic.Text = "OrthogonalDynamic";
            // 
            // checkBoxLogical
            // 
            this.checkBoxLogical.Location = new System.Drawing.Point(16, 112);
            this.checkBoxLogical.Name = "checkBoxLogical";
            this.checkBoxLogical.Size = new System.Drawing.Size(128, 24);
            this.checkBoxLogical.TabIndex = 3;
            this.checkBoxLogical.Text = "Logical";
            // 
            // checkBoxHidden
            // 
            this.checkBoxHidden.Location = new System.Drawing.Point(16, 80);
            this.checkBoxHidden.Name = "checkBoxHidden";
            this.checkBoxHidden.Size = new System.Drawing.Size(128, 24);
            this.checkBoxHidden.TabIndex = 2;
            this.checkBoxHidden.Text = "Hidden";
            // 
            // checkBoxAdjustDst
            // 
            this.checkBoxAdjustDst.Location = new System.Drawing.Point(16, 48);
            this.checkBoxAdjustDst.Name = "checkBoxAdjustDst";
            this.checkBoxAdjustDst.Size = new System.Drawing.Size(128, 24);
            this.checkBoxAdjustDst.TabIndex = 1;
            this.checkBoxAdjustDst.Text = "AdjustDst";
            // 
            // checkBoxAdjustOrg
            // 
            this.checkBoxAdjustOrg.Location = new System.Drawing.Point(16, 16);
            this.checkBoxAdjustOrg.Name = "checkBoxAdjustOrg";
            this.checkBoxAdjustOrg.Size = new System.Drawing.Size(128, 24);
            this.checkBoxAdjustOrg.TabIndex = 0;
            this.checkBoxAdjustOrg.Text = "AdjustOrg";
            // 
            // tabPage2
            // 
            this.tabPage2.Controls.Add(this.textBoxUrl);
            this.tabPage2.Controls.Add(this.label17);
            this.tabPage2.Controls.Add(this.textBoxTooltip);
            this.tabPage2.Controls.Add(this.label16);
            this.tabPage2.Controls.Add(this.buttonFont);
            this.tabPage2.Controls.Add(this.textBoxText);
            this.tabPage2.Controls.Add(this.label13);
            this.tabPage2.Location = new System.Drawing.Point(4, 22);
            this.tabPage2.Name = "tabPage2";
            this.tabPage2.Size = new System.Drawing.Size(432, 254);
            this.tabPage2.TabIndex = 1;
            this.tabPage2.Text = "Text and Font";
            // 
            // textBoxUrl
            // 
            this.textBoxUrl.Location = new System.Drawing.Point(16, 152);
            this.textBoxUrl.Name = "textBoxUrl";
            this.textBoxUrl.Size = new System.Drawing.Size(264, 20);
            this.textBoxUrl.TabIndex = 31;
            // 
            // label17
            // 
            this.label17.AutoSize = true;
            this.label17.Location = new System.Drawing.Point(16, 136);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(20, 13);
            this.label17.TabIndex = 30;
            this.label17.Text = "Url";
            // 
            // textBoxTooltip
            // 
            this.textBoxTooltip.Location = new System.Drawing.Point(16, 80);
            this.textBoxTooltip.Multiline = true;
            this.textBoxTooltip.Name = "textBoxTooltip";
            this.textBoxTooltip.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.textBoxTooltip.Size = new System.Drawing.Size(264, 48);
            this.textBoxTooltip.TabIndex = 29;
            // 
            // label16
            // 
            this.label16.AutoSize = true;
            this.label16.Location = new System.Drawing.Point(16, 64);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(39, 13);
            this.label16.TabIndex = 28;
            this.label16.Text = "Tooltip";
            // 
            // buttonFont
            // 
            this.buttonFont.Location = new System.Drawing.Point(312, 32);
            this.buttonFont.Name = "buttonFont";
            this.buttonFont.Size = new System.Drawing.Size(56, 24);
            this.buttonFont.TabIndex = 27;
            this.buttonFont.Text = "Font...";
            this.buttonFont.Click += new System.EventHandler(this.buttonFont_Click);
            // 
            // textBoxText
            // 
            this.textBoxText.Location = new System.Drawing.Point(16, 32);
            this.textBoxText.Name = "textBoxText";
            this.textBoxText.Size = new System.Drawing.Size(264, 20);
            this.textBoxText.TabIndex = 0;
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Location = new System.Drawing.Point(16, 16);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(28, 13);
            this.label13.TabIndex = 6;
            this.label13.Text = "Text";
            // 
            // tabPage4
            // 
            this.tabPage4.Controls.Add(this.buttonTextColor);
            this.tabPage4.Controls.Add(this.buttonDrawColor);
            this.tabPage4.Controls.Add(this.labelTextColor);
            this.tabPage4.Controls.Add(this.labelDrawColor);
            this.tabPage4.Location = new System.Drawing.Point(4, 22);
            this.tabPage4.Name = "tabPage4";
            this.tabPage4.Size = new System.Drawing.Size(432, 254);
            this.tabPage4.TabIndex = 3;
            this.tabPage4.Text = "Colors";
            // 
            // buttonTextColor
            // 
            this.buttonTextColor.Location = new System.Drawing.Point(24, 64);
            this.buttonTextColor.Name = "buttonTextColor";
            this.buttonTextColor.Size = new System.Drawing.Size(80, 24);
            this.buttonTextColor.TabIndex = 9;
            this.buttonTextColor.Text = "TextColor...";
            this.buttonTextColor.Click += new System.EventHandler(this.buttonTextColor_Click_1);
            // 
            // buttonDrawColor
            // 
            this.buttonDrawColor.Location = new System.Drawing.Point(24, 24);
            this.buttonDrawColor.Name = "buttonDrawColor";
            this.buttonDrawColor.Size = new System.Drawing.Size(80, 24);
            this.buttonDrawColor.TabIndex = 8;
            this.buttonDrawColor.Text = "DrawColor...";
            this.buttonDrawColor.Click += new System.EventHandler(this.buttonDrawColor_Click_1);
            // 
            // labelTextColor
            // 
            this.labelTextColor.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.labelTextColor.Location = new System.Drawing.Point(120, 64);
            this.labelTextColor.Name = "labelTextColor";
            this.labelTextColor.Size = new System.Drawing.Size(48, 24);
            this.labelTextColor.TabIndex = 7;
            // 
            // labelDrawColor
            // 
            this.labelDrawColor.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.labelDrawColor.Location = new System.Drawing.Point(120, 24);
            this.labelDrawColor.Name = "labelDrawColor";
            this.labelDrawColor.Size = new System.Drawing.Size(48, 24);
            this.labelDrawColor.TabIndex = 6;
            // 
            // tabControl1
            // 
            this.tabControl1.Controls.Add(this.tabPage1);
            this.tabControl1.Controls.Add(this.tabPage2);
            this.tabControl1.Controls.Add(this.tabPage4);
            this.tabControl1.Controls.Add(this.tabPage3);
            this.tabControl1.ItemSize = new System.Drawing.Size(42, 18);
            this.tabControl1.Location = new System.Drawing.Point(8, 16);
            this.tabControl1.Name = "tabControl1";
            this.tabControl1.SelectedIndex = 0;
            this.tabControl1.Size = new System.Drawing.Size(440, 280);
            this.tabControl1.TabIndex = 0;
            // 
            // LinkPropertyPage
            // 
            this.ClientSize = new System.Drawing.Size(456, 335);
            this.ControlBox = false;
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.tabControl1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "LinkPropertyPage";
            this.ShowInTaskbar = false;
            this.Text = "Link properties";
            this.Load += new System.EventHandler(this.NodePropertyPage_Load);
            this.tabPage1.ResumeLayout(false);
            this.tabPage1.PerformLayout();
            this.tabPage3.ResumeLayout(false);
            this.tabPage2.ResumeLayout(false);
            this.tabPage2.PerformLayout();
            this.tabPage4.ResumeLayout(false);
            this.tabControl1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion
        
        /// <summary>Returns/sets the reference to the Link object</summary>
        public Link Link
        {
            get { return m_link; }
            set { m_link = value; }
        }

        /// <summary>Returns/sets the reference to the AddFlow object</summary>
        public AddFlow AddFlow
        {
            get { return m_addflow; }
            set { m_addflow = value; }
        }

        private void NodePropertyPage_Load(object sender, System.EventArgs e)
        {            
            // Fill the combo boxes
            foreach (LineStyle v in Enum.GetValues(typeof(LineStyle)))
                comboBoxLinkStyle.Items.Add(v.ToString());
            foreach (Jump v in Enum.GetValues(typeof(Jump)))
                comboBoxJump.Items.Add(v.ToString());
            foreach (DashStyle v in Enum.GetValues(typeof(DashStyle)))
                comboBoxDashStyle.Items.Add(v.ToString());
            for (int i = 0; i <= 16; i++)
                comboBoxPenWidth.Items.Add(i);
            foreach (ConnectionStyle v in Enum.GetValues(typeof(ConnectionStyle)))
            {
                comboBoxConnectionStyleOrg.Items.Add(v.ToString());
                comboBoxConnectionStyleDst.Items.Add(v.ToString());
            }

            if (m_link != null)
            {
                textBoxArrowDst.Text = m_link.ArrowDst.ToString();
                textBoxArrowOrg.Text = m_link.ArrowOrg.ToString();
                textBoxArrowMid.Text = m_link.ArrowMid.ToString();
                comboBoxStartCap.Items.Add(LineCap.Flat);
                comboBoxStartCap.Items.Add(LineCap.Square);
                comboBoxStartCap.Items.Add(LineCap.Round);
                comboBoxStartCap.Items.Add(LineCap.Triangle);
                comboBoxStartCap.Items.Add(LineCap.SquareAnchor);
                comboBoxStartCap.Items.Add(LineCap.RoundAnchor);
                comboBoxStartCap.Items.Add(LineCap.DiamondAnchor);
                comboBoxStartCap.Items.Add(LineCap.ArrowAnchor);
                comboBoxStartCap.Items.Add(LineCap.Custom);
                comboBoxStartCap.SelectedItem = m_link.StartCap;            
                comboBoxEndCap.Items.Add(LineCap.Flat);
                comboBoxEndCap.Items.Add(LineCap.Square);
                comboBoxEndCap.Items.Add(LineCap.Round);
                comboBoxEndCap.Items.Add(LineCap.Triangle);
                comboBoxEndCap.Items.Add(LineCap.SquareAnchor);
                comboBoxEndCap.Items.Add(LineCap.RoundAnchor);
                comboBoxEndCap.Items.Add(LineCap.DiamondAnchor);
                comboBoxEndCap.Items.Add(LineCap.ArrowAnchor);
                comboBoxEndCap.Items.Add(LineCap.Custom);
                comboBoxEndCap.SelectedItem = m_link.EndCap;
                comboBoxLinkStyle.SelectedItem = m_link.Line.Style.ToString();
                comboBoxJump.SelectedItem = m_link.Jump.ToString();
                comboBoxDashStyle.SelectedItem = m_link.DashStyle.ToString();
                comboBoxConnectionStyleOrg.SelectedItem = m_link.ConnectionStyleOrg.ToString();
                comboBoxConnectionStyleDst.SelectedItem = m_link.ConnectionStyleDst.ToString();
                comboBoxPenWidth.SelectedItem = m_link.DrawWidth;            
                checkBoxAdjustDst.Checked = m_link.AdjustDst;
                checkBoxAdjustOrg.Checked = m_link.AdjustOrg;
                checkBoxHidden.Checked = m_link.Hidden;
                checkBoxOwnerDraw.Checked = m_link.OwnerDraw;
                checkBoxLogical.Checked = m_link.Logical;
                checkBoxOrthogonalDynamic.Checked = m_link.Line.OrthogonalDynamic;
                checkBoxRoundedCorner.Checked = m_link.Line.RoundedCorner;
                checkBoxOrientedText.Checked = m_link.OrientedText;
                checkBoxRigid.Checked = m_link.Rigid;
                checkBoxSelectable.Checked = m_link.Selectable;
                checkBoxStretchable.Checked = m_link.Stretchable;
                checkBoxHighlightChildren.Checked = m_link.HighlightChildren;
                checkBoxRemoveChildren.Checked = m_link.RemoveChildren;          
				textBoxText.Text = m_link.Text;          
				textBoxTooltip.Text = m_link.Tooltip;   
				textBoxUrl.Text = m_link.Url;                    
                labelDrawColor.BackColor = m_link.DrawColor;
                labelTextColor.BackColor = m_link.TextColor;            
                textBoxText.Font = m_link.Font;
            }
            else
            {
                textBoxArrowDst.Text = m_addflow.DefLinkProp.ArrowDst.ToString();
                textBoxArrowOrg.Text = m_addflow.DefLinkProp.ArrowOrg.ToString();
                textBoxArrowMid.Text = m_addflow.DefLinkProp.ArrowMid.ToString();
                comboBoxStartCap.Items.Add(LineCap.Flat);
                comboBoxStartCap.Items.Add(LineCap.Square);
                comboBoxStartCap.Items.Add(LineCap.Round);
                comboBoxStartCap.Items.Add(LineCap.Triangle);
                comboBoxStartCap.Items.Add(LineCap.SquareAnchor);
                comboBoxStartCap.Items.Add(LineCap.RoundAnchor);
                comboBoxStartCap.Items.Add(LineCap.DiamondAnchor);
                comboBoxStartCap.Items.Add(LineCap.ArrowAnchor);
                comboBoxStartCap.Items.Add(LineCap.Custom);
                comboBoxStartCap.SelectedItem = m_addflow.DefLinkProp.StartCap;            
                comboBoxEndCap.Items.Add(LineCap.Flat);
                comboBoxEndCap.Items.Add(LineCap.Square);
                comboBoxEndCap.Items.Add(LineCap.Round);
                comboBoxEndCap.Items.Add(LineCap.Triangle);
                comboBoxEndCap.Items.Add(LineCap.SquareAnchor);
                comboBoxEndCap.Items.Add(LineCap.RoundAnchor);
                comboBoxEndCap.Items.Add(LineCap.DiamondAnchor);
                comboBoxEndCap.Items.Add(LineCap.ArrowAnchor);
                comboBoxEndCap.Items.Add(LineCap.Custom);
                comboBoxEndCap.SelectedItem = m_addflow.DefLinkProp.EndCap;
                comboBoxLinkStyle.SelectedItem = m_addflow.DefLinkProp.Line.Style.ToString();
                comboBoxJump.SelectedItem = m_addflow.DefLinkProp.Jump.ToString();
                comboBoxDashStyle.SelectedItem = m_addflow.DefLinkProp.DashStyle.ToString();
                comboBoxConnectionStyleOrg.SelectedItem = m_addflow.DefLinkProp.ConnectionStyleOrg.ToString();
                comboBoxConnectionStyleDst.SelectedItem = m_addflow.DefLinkProp.ConnectionStyleDst.ToString();
                comboBoxPenWidth.SelectedItem = m_addflow.DefLinkProp.DrawWidth;            
                checkBoxAdjustDst.Checked = m_addflow.DefLinkProp.AdjustDst;
                checkBoxAdjustOrg.Checked = m_addflow.DefLinkProp.AdjustOrg;
                checkBoxHidden.Checked = m_addflow.DefLinkProp.Hidden;
                checkBoxOwnerDraw.Checked = m_addflow.DefLinkProp.OwnerDraw;
                checkBoxLogical.Checked = m_addflow.DefLinkProp.Logical;
                checkBoxOrthogonalDynamic.Checked = m_addflow.DefLinkProp.Line.OrthogonalDynamic;
                checkBoxRoundedCorner.Checked = m_addflow.DefLinkProp.Line.RoundedCorner;
                checkBoxOrientedText.Checked = m_addflow.DefLinkProp.OrientedText;
                checkBoxRigid.Checked = m_addflow.DefLinkProp.Rigid;
                checkBoxSelectable.Checked = m_addflow.DefLinkProp.Selectable;
                checkBoxStretchable.Checked = m_addflow.DefLinkProp.Stretchable;
                checkBoxHighlightChildren.Checked = m_addflow.DefLinkProp.HighlightChildren;
                checkBoxRemoveChildren.Checked = m_addflow.DefLinkProp.RemoveChildren; 
				textBoxText.Text = m_addflow.DefLinkProp.Text;                
				textBoxTooltip.Text = m_addflow.DefLinkProp.Tooltip;  
				textBoxUrl.Text = m_addflow.DefLinkProp.Url;                             
                labelDrawColor.BackColor = m_addflow.DefLinkProp.DrawColor;
                labelTextColor.BackColor = m_addflow.DefLinkProp.TextColor;            
                textBoxText.Font = m_addflow.DefLinkProp.Font;
            }
        }

        private void button1_Click(object sender, System.EventArgs e)
        {
            Arrow arrow;

            if (m_link != null)
            {
                arrow = new Arrow(textBoxArrowDst.Text);            
                if (m_link.ArrowDst.Style != arrow.Style || 
                    m_link.ArrowDst.Size != arrow.Size ||
                    m_link.ArrowDst.Angle != arrow.Angle || 
                    m_link.ArrowDst.Filled != arrow.Filled)
                    m_link.ArrowDst = (Arrow)arrow.Clone();

                arrow = new Arrow(textBoxArrowOrg.Text);           
                if (m_link.ArrowOrg.Style != arrow.Style || 
                    m_link.ArrowOrg.Size != arrow.Size ||
                    m_link.ArrowOrg.Angle != arrow.Angle || 
                    m_link.ArrowOrg.Filled != arrow.Filled)
                    m_link.ArrowOrg = (Arrow)arrow.Clone();

                arrow = new Arrow(textBoxArrowMid.Text);            
                if (m_link.ArrowMid.Style != arrow.Style || 
                    m_link.ArrowMid.Size != arrow.Size ||
                    m_link.ArrowMid.Angle != arrow.Angle || 
                    m_link.ArrowMid.Filled != arrow.Filled)
                    m_link.ArrowMid = (Arrow)arrow.Clone();
                        
                LineStyle st = (LineStyle)comboBoxLinkStyle.SelectedIndex;
                bool b1 = (checkBoxOrthogonalDynamic.Checked == true);
                bool b2 = (checkBoxRoundedCorner.Checked == true);
                if (m_link.Line.OrthogonalDynamic != b1 || 
                    m_link.Line.RoundedCorner != b2 ||
                    m_link.Line.Style != st)
                    m_link.Line = new Line(st, b1, b2);

                LineCap startcap = (LineCap)Enum.Parse(typeof(LineCap), comboBoxStartCap.Text, false);
                if (m_link.StartCap != startcap)
                    m_link.StartCap = startcap;            
            
                LineCap endcap = (LineCap)Enum.Parse(typeof(LineCap), comboBoxEndCap.Text, false);
                if (m_link.EndCap != endcap)
                    m_link.EndCap = endcap;            

                if (m_link.Jump != (Jump)comboBoxJump.SelectedIndex)
                    m_link.Jump = (Jump)comboBoxJump.SelectedIndex;
                if (m_link.DashStyle != (DashStyle)comboBoxDashStyle.SelectedIndex)
                    m_link.DashStyle = (DashStyle)comboBoxDashStyle.SelectedIndex;
                if (m_link.DrawWidth != comboBoxPenWidth.SelectedIndex)
                    m_link.DrawWidth = comboBoxPenWidth.SelectedIndex;
                if (m_link.ConnectionStyleOrg != (ConnectionStyle)comboBoxConnectionStyleOrg.SelectedIndex)
                    m_link.ConnectionStyleOrg = (ConnectionStyle)comboBoxConnectionStyleOrg.SelectedIndex;
                if (m_link.ConnectionStyleDst != (ConnectionStyle)comboBoxConnectionStyleDst.SelectedIndex)
                    m_link.ConnectionStyleDst = (ConnectionStyle)comboBoxConnectionStyleDst.SelectedIndex;

                if (m_link.AdjustOrg!= checkBoxAdjustOrg.Checked)
                    m_link.AdjustOrg= checkBoxAdjustOrg.Checked;
                if (m_link.AdjustDst != checkBoxAdjustDst.Checked)
                    m_link.AdjustDst = checkBoxAdjustDst.Checked;
                if (m_link.Hidden != checkBoxHidden.Checked)
                    m_link.Hidden = checkBoxHidden.Checked;
                if (m_link.OwnerDraw != checkBoxOwnerDraw.Checked)
                    m_link.OwnerDraw = checkBoxOwnerDraw.Checked;
                if (m_link.Logical != checkBoxLogical.Checked)
                    m_link.Logical = checkBoxLogical.Checked;
                if (m_link.OrientedText != checkBoxOrientedText.Checked)
                    m_link.OrientedText = checkBoxOrientedText.Checked;
                if (m_link.Rigid != checkBoxRigid.Checked)
                    m_link.Rigid = checkBoxRigid.Checked;
                if (m_link.Selectable != checkBoxSelectable.Checked)
                    m_link.Selectable = checkBoxSelectable.Checked;
                if (m_link.Stretchable != checkBoxStretchable.Checked)
                    m_link.Stretchable = checkBoxStretchable.Checked;
                if (m_link.HighlightChildren != checkBoxHighlightChildren.Checked)
                    m_link.HighlightChildren = checkBoxHighlightChildren.Checked;
                if (m_link.RemoveChildren != checkBoxRemoveChildren.Checked)
                    m_link.RemoveChildren = checkBoxRemoveChildren.Checked;
            
				if ((m_link.Text != null && !m_link.Text.Equals(textBoxText.Text)) || 
					(m_link.Text == null && textBoxText.Text != ""))
					m_link.Text = textBoxText.Text;
				if ((m_link.Tooltip != null && !m_link.Tooltip.Equals(textBoxTooltip.Text)) || 
					(m_link.Tooltip == null && textBoxTooltip.Text != ""))
					m_link.Tooltip = textBoxTooltip.Text;
				if ((m_link.Url != null && !m_link.Url.Equals(textBoxUrl.Text)) || 
					(m_link.Url == null && textBoxUrl.Text != ""))
					m_link.Url = textBoxUrl.Text;
            
                if (m_link.DrawColor != labelDrawColor.BackColor)
                    m_link.DrawColor = labelDrawColor.BackColor;
                if (m_link.TextColor != labelTextColor.BackColor)
                    m_link.TextColor = labelTextColor.BackColor;

                if (m_link.Font != null)
                {
                    if (!m_link.Font.Equals(textBoxText.Font))
                        m_link.Font = textBoxText.Font;
                }
                else if (textBoxText.Font != null)
                    m_link.Font = textBoxText.Font;
                m_link.Refresh();
            }
            else
            {
                arrow = new Arrow(textBoxArrowDst.Text);            
                if (m_addflow.DefLinkProp.ArrowDst.Style != arrow.Style || 
                    m_addflow.DefLinkProp.ArrowDst.Size != arrow.Size ||
                    m_addflow.DefLinkProp.ArrowDst.Angle != arrow.Angle || 
                    m_addflow.DefLinkProp.ArrowDst.Filled != arrow.Filled)
                    m_addflow.DefLinkProp.ArrowDst = (Arrow)arrow.Clone();

                arrow = new Arrow(textBoxArrowOrg.Text);           
                if (m_addflow.DefLinkProp.ArrowOrg.Style != arrow.Style || 
                    m_addflow.DefLinkProp.ArrowOrg.Size != arrow.Size ||
                    m_addflow.DefLinkProp.ArrowOrg.Angle != arrow.Angle || 
                    m_addflow.DefLinkProp.ArrowOrg.Filled != arrow.Filled)
                    m_addflow.DefLinkProp.ArrowOrg = (Arrow)arrow.Clone();

                arrow = new Arrow(textBoxArrowMid.Text);            
                if (m_addflow.DefLinkProp.ArrowMid.Style != arrow.Style || 
                    m_addflow.DefLinkProp.ArrowMid.Size != arrow.Size ||
                    m_addflow.DefLinkProp.ArrowMid.Angle != arrow.Angle || 
                    m_addflow.DefLinkProp.ArrowMid.Filled != arrow.Filled)
                    m_addflow.DefLinkProp.ArrowMid = (Arrow)arrow.Clone();
                        
                LineStyle st = (LineStyle)comboBoxLinkStyle.SelectedIndex;
                bool b1 = (checkBoxOrthogonalDynamic.Checked == true);
                bool b2 = (checkBoxRoundedCorner.Checked == true);
                if (m_addflow.DefLinkProp.Line.OrthogonalDynamic != b1 || 
                    m_addflow.DefLinkProp.Line.RoundedCorner != b2 ||
                    m_addflow.DefLinkProp.Line.Style != st)
                    m_addflow.DefLinkProp.Line = new Line(st, b1, b2);

                LineCap startcap = (LineCap)Enum.Parse(typeof(LineCap), comboBoxStartCap.Text, false);
                if (m_addflow.DefLinkProp.StartCap != startcap)
                    m_addflow.DefLinkProp.StartCap = startcap;            
            
                LineCap endcap = (LineCap)Enum.Parse(typeof(LineCap), comboBoxEndCap.Text, false);
                if (m_addflow.DefLinkProp.EndCap != endcap)
                    m_addflow.DefLinkProp.EndCap = endcap;            

                if (m_addflow.DefLinkProp.Jump != (Jump)comboBoxJump.SelectedIndex)
                    m_addflow.DefLinkProp.Jump = (Jump)comboBoxJump.SelectedIndex;
                if (m_addflow.DefLinkProp.DashStyle != (DashStyle)comboBoxDashStyle.SelectedIndex)
                    m_addflow.DefLinkProp.DashStyle = (DashStyle)comboBoxDashStyle.SelectedIndex;
                if (m_addflow.DefLinkProp.DrawWidth != comboBoxPenWidth.SelectedIndex)
                    m_addflow.DefLinkProp.DrawWidth = comboBoxPenWidth.SelectedIndex;
                if (m_addflow.DefLinkProp.ConnectionStyleOrg != (ConnectionStyle)comboBoxConnectionStyleOrg.SelectedIndex)
                    m_addflow.DefLinkProp.ConnectionStyleOrg = (ConnectionStyle)comboBoxConnectionStyleOrg.SelectedIndex;
                if (m_addflow.DefLinkProp.ConnectionStyleDst != (ConnectionStyle)comboBoxConnectionStyleDst.SelectedIndex)
                    m_addflow.DefLinkProp.ConnectionStyleDst = (ConnectionStyle)comboBoxConnectionStyleDst.SelectedIndex;

                if (m_addflow.DefLinkProp.AdjustOrg!= checkBoxAdjustOrg.Checked)
                    m_addflow.DefLinkProp.AdjustOrg= checkBoxAdjustOrg.Checked;
                if (m_addflow.DefLinkProp.AdjustDst != checkBoxAdjustDst.Checked)
                    m_addflow.DefLinkProp.AdjustDst = checkBoxAdjustDst.Checked;
                if (m_addflow.DefLinkProp.Hidden != checkBoxHidden.Checked)
                    m_addflow.DefLinkProp.Hidden = checkBoxHidden.Checked;
                if (m_addflow.DefLinkProp.OwnerDraw != checkBoxOwnerDraw.Checked)
                    m_addflow.DefLinkProp.OwnerDraw = checkBoxOwnerDraw.Checked;
                if (m_addflow.DefLinkProp.Logical != checkBoxLogical.Checked)
                    m_addflow.DefLinkProp.Logical = checkBoxLogical.Checked;
                if (m_addflow.DefLinkProp.OrientedText != checkBoxOrientedText.Checked)
                    m_addflow.DefLinkProp.OrientedText = checkBoxOrientedText.Checked;
                if (m_addflow.DefLinkProp.Rigid != checkBoxRigid.Checked)
                    m_addflow.DefLinkProp.Rigid = checkBoxRigid.Checked;
                if (m_addflow.DefLinkProp.Selectable != checkBoxSelectable.Checked)
                    m_addflow.DefLinkProp.Selectable = checkBoxSelectable.Checked;
                if (m_addflow.DefLinkProp.Stretchable != checkBoxStretchable.Checked)
                    m_addflow.DefLinkProp.Stretchable = checkBoxStretchable.Checked;
                if (m_addflow.DefLinkProp.HighlightChildren != checkBoxHighlightChildren.Checked)
                    m_addflow.DefLinkProp.HighlightChildren = checkBoxHighlightChildren.Checked;
                if (m_addflow.DefLinkProp.RemoveChildren != checkBoxRemoveChildren.Checked)
                    m_addflow.DefLinkProp.RemoveChildren = checkBoxRemoveChildren.Checked;
            				
				if ((m_addflow.DefLinkProp.Text != null && !m_addflow.DefLinkProp.Text.Equals(textBoxText.Text)) || 
					(m_addflow.DefLinkProp.Text == null && textBoxText.Text != ""))
					m_addflow.DefLinkProp.Text = textBoxText.Text;
				if ((m_addflow.DefLinkProp.Tooltip != null && !m_addflow.DefLinkProp.Tooltip.Equals(textBoxTooltip.Text)) || 
					(m_addflow.DefLinkProp.Tooltip == null && textBoxTooltip.Text != ""))
					m_addflow.DefLinkProp.Tooltip = textBoxTooltip.Text;
				if ((m_addflow.DefLinkProp.Url != null && !m_addflow.DefLinkProp.Url.Equals(textBoxUrl.Text)) || 
					(m_addflow.DefLinkProp.Url == null && textBoxUrl.Text != ""))
					m_addflow.DefLinkProp.Url = textBoxUrl.Text;
            
                if (m_addflow.DefLinkProp.DrawColor != labelDrawColor.BackColor)
                    m_addflow.DefLinkProp.DrawColor = labelDrawColor.BackColor;
                if (m_addflow.DefLinkProp.TextColor != labelTextColor.BackColor)
                    m_addflow.DefLinkProp.TextColor = labelTextColor.BackColor;

                if (m_addflow.DefLinkProp.Font != null)
                {
                    if (!m_addflow.DefLinkProp.Font.Equals(textBoxText.Font))
                        m_addflow.DefLinkProp.Font = textBoxText.Font;
                }
                else if (textBoxText.Font != null)
                    m_addflow.DefLinkProp.Font = textBoxText.Font;
            }
        }
        
        private void buttonDrawColor_Click_1(object sender, System.EventArgs e)
        {
            ColorDialog clrdlg = new ColorDialog();
            clrdlg.Color = labelDrawColor.BackColor;
            if (clrdlg.ShowDialog() == DialogResult.OK)
                labelDrawColor.BackColor = clrdlg.Color;
        }

        private void buttonTextColor_Click_1(object sender, System.EventArgs e)
        {
            ColorDialog clrdlg = new ColorDialog();
            clrdlg.Color = labelTextColor.BackColor;
            if (clrdlg.ShowDialog() == DialogResult.OK)
                labelTextColor.BackColor = clrdlg.Color;       
        }

        private void buttonFont_Click(object sender, System.EventArgs e)
        {         
            FontDialog fontdlg = new FontDialog();
            fontdlg.Font = textBoxText.Font;
            if (fontdlg.ShowDialog() == DialogResult.OK)
                textBoxText.Font = fontdlg.Font;
        }

        private void buttonArrowDst_Click(object sender, System.EventArgs e)
        {            
            ArrowDlg arrowdlg = new ArrowDlg();
            arrowdlg.Arrow = 
                (m_link != null) ? m_link.ArrowDst : m_addflow.DefLinkProp.ArrowDst;
            if (arrowdlg.ShowDialog() == DialogResult.OK)
                textBoxArrowDst.Text = arrowdlg.Arrow.ToString();
        }

        private void buttonArrowOrg_Click(object sender, System.EventArgs e)
        {        
            ArrowDlg arrowdlg = new ArrowDlg();
            arrowdlg.Arrow = 
                (m_link != null) ? m_link.ArrowOrg : m_addflow.DefLinkProp.ArrowOrg;
            if (arrowdlg.ShowDialog() == DialogResult.OK)
                textBoxArrowOrg.Text = arrowdlg.Arrow.ToString();
        }

        private void buttonArrowMid_Click(object sender, System.EventArgs e)
        {        
            ArrowDlg arrowdlg = new ArrowDlg();
            arrowdlg.Arrow = 
                (m_link != null) ? m_link.ArrowMid : m_addflow.DefLinkProp.ArrowMid;
            if (arrowdlg.ShowDialog() == DialogResult.OK)
                textBoxArrowMid.Text = arrowdlg.Arrow.ToString();
        }
    }
}
