using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Lassalle.Flow;

namespace Lassalle.DlgFlow
{
	internal class NodePropertyPage : System.Windows.Forms.Form
	{
        private System.Windows.Forms.TabControl tabControl1;
        private System.Windows.Forms.TabPage tabPage1;
        private System.Windows.Forms.TabPage tabPage2;
        private System.Windows.Forms.TabPage tabPage3;
        private System.Windows.Forms.TabPage tabPage4;
        private System.Windows.Forms.Button button1;
        private System.Windows.Forms.Button button2;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.ComboBox comboBoxShape;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.ComboBox comboBoxDashStyle;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.ComboBox comboBoxPenWidth;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.ComboBox comboBoxShapeOrientation;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.ComboBox comboBoxImagePosition;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.ComboBox comboBoxAlignment;
        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.ComboBox comboBoxShadow;
        private System.Windows.Forms.Label label8;
        private System.Windows.Forms.ComboBox comboBoxAutoSize;
        private System.Windows.Forms.CheckBox checkBoxTransparent;
        private System.Windows.Forms.CheckBox checkBoxHidden;
        private System.Windows.Forms.CheckBox checkBoxSelectable;
        private System.Windows.Forms.CheckBox checkBoxLogical;
        private System.Windows.Forms.CheckBox checkBoxXMoveable;
        private System.Windows.Forms.CheckBox checkBoxYMoveable;
        private System.Windows.Forms.CheckBox checkBoxXSizeable;
        private System.Windows.Forms.CheckBox checkBoxYSizeable;
        private System.Windows.Forms.Label label13;
        private System.Windows.Forms.TextBox textBoxText;
        private System.Windows.Forms.CheckBox checkBoxOwnerDraw;
        private System.Windows.Forms.Label labelFillColor;
        private System.Windows.Forms.Label labelDrawColor;
        private System.Windows.Forms.Label labelTextColor;
        private System.Windows.Forms.Button buttonFillColor;
        private System.Windows.Forms.Button buttonDrawColor;
        private System.Windows.Forms.Button buttonTextColor;
        private System.Windows.Forms.Label labelShadowColor;
        private System.Windows.Forms.Button buttonShadowColor;
        private System.Windows.Forms.CheckBox checkBoxLabelEdit;
        private System.Windows.Forms.Label label9;
        private System.Windows.Forms.TextBox textBoxImageIndex;
        private System.Windows.Forms.Button buttonFont;
        private System.Windows.Forms.ComboBox comboBoxYTextMargin;
        private System.Windows.Forms.ComboBox comboBoxXTextMargin;
        private System.Windows.Forms.Label label10;
        private System.Windows.Forms.Label label11;
        private System.Windows.Forms.Label label12;
        private System.Windows.Forms.Label label14;
        private System.Windows.Forms.ComboBox comboBoxTrimming;

        private AddFlow m_addflow = null;
		private System.Windows.Forms.CheckBox checkBoxInLinkable;
		private System.Windows.Forms.CheckBox checkBoxOutLinkable;
		private System.Windows.Forms.CheckBox checkBoxGradient;
		private System.Windows.Forms.Button buttonGradientColor;
		private System.Windows.Forms.Label labelGradientColor;
		private System.Windows.Forms.ComboBox comboBoxGradientMode;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.TextBox textBoxTooltip;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.TextBox textBoxUrl;
        private Label label18;
        private ComboBox comboBoxAttachmentStyle;
        private Label label19;
        private ComboBox comboBoxDock;
        private CheckBox checkBoxRemoveChildren;
        private CheckBox checkBoxHighlightChildren;
        private Node m_node = null;

		public NodePropertyPage()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.tabControl1 = new System.Windows.Forms.TabControl();
            this.tabPage1 = new System.Windows.Forms.TabPage();
            this.label19 = new System.Windows.Forms.Label();
            this.comboBoxDock = new System.Windows.Forms.ComboBox();
            this.label18 = new System.Windows.Forms.Label();
            this.comboBoxAttachmentStyle = new System.Windows.Forms.ComboBox();
            this.comboBoxGradientMode = new System.Windows.Forms.ComboBox();
            this.label15 = new System.Windows.Forms.Label();
            this.comboBoxTrimming = new System.Windows.Forms.ComboBox();
            this.label14 = new System.Windows.Forms.Label();
            this.label12 = new System.Windows.Forms.Label();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.comboBoxYTextMargin = new System.Windows.Forms.ComboBox();
            this.comboBoxXTextMargin = new System.Windows.Forms.ComboBox();
            this.comboBoxAutoSize = new System.Windows.Forms.ComboBox();
            this.label8 = new System.Windows.Forms.Label();
            this.comboBoxShadow = new System.Windows.Forms.ComboBox();
            this.label7 = new System.Windows.Forms.Label();
            this.comboBoxAlignment = new System.Windows.Forms.ComboBox();
            this.label6 = new System.Windows.Forms.Label();
            this.comboBoxImagePosition = new System.Windows.Forms.ComboBox();
            this.label5 = new System.Windows.Forms.Label();
            this.comboBoxShapeOrientation = new System.Windows.Forms.ComboBox();
            this.label4 = new System.Windows.Forms.Label();
            this.comboBoxPenWidth = new System.Windows.Forms.ComboBox();
            this.label3 = new System.Windows.Forms.Label();
            this.comboBoxDashStyle = new System.Windows.Forms.ComboBox();
            this.label2 = new System.Windows.Forms.Label();
            this.comboBoxShape = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.tabPage4 = new System.Windows.Forms.TabPage();
            this.buttonGradientColor = new System.Windows.Forms.Button();
            this.labelGradientColor = new System.Windows.Forms.Label();
            this.buttonShadowColor = new System.Windows.Forms.Button();
            this.labelShadowColor = new System.Windows.Forms.Label();
            this.buttonTextColor = new System.Windows.Forms.Button();
            this.buttonDrawColor = new System.Windows.Forms.Button();
            this.buttonFillColor = new System.Windows.Forms.Button();
            this.labelTextColor = new System.Windows.Forms.Label();
            this.labelDrawColor = new System.Windows.Forms.Label();
            this.labelFillColor = new System.Windows.Forms.Label();
            this.tabPage2 = new System.Windows.Forms.TabPage();
            this.checkBoxRemoveChildren = new System.Windows.Forms.CheckBox();
            this.checkBoxHighlightChildren = new System.Windows.Forms.CheckBox();
            this.checkBoxGradient = new System.Windows.Forms.CheckBox();
            this.checkBoxOutLinkable = new System.Windows.Forms.CheckBox();
            this.checkBoxInLinkable = new System.Windows.Forms.CheckBox();
            this.checkBoxLabelEdit = new System.Windows.Forms.CheckBox();
            this.checkBoxOwnerDraw = new System.Windows.Forms.CheckBox();
            this.checkBoxYSizeable = new System.Windows.Forms.CheckBox();
            this.checkBoxXSizeable = new System.Windows.Forms.CheckBox();
            this.checkBoxYMoveable = new System.Windows.Forms.CheckBox();
            this.checkBoxXMoveable = new System.Windows.Forms.CheckBox();
            this.checkBoxLogical = new System.Windows.Forms.CheckBox();
            this.checkBoxSelectable = new System.Windows.Forms.CheckBox();
            this.checkBoxHidden = new System.Windows.Forms.CheckBox();
            this.checkBoxTransparent = new System.Windows.Forms.CheckBox();
            this.tabPage3 = new System.Windows.Forms.TabPage();
            this.textBoxUrl = new System.Windows.Forms.TextBox();
            this.label17 = new System.Windows.Forms.Label();
            this.textBoxTooltip = new System.Windows.Forms.TextBox();
            this.label16 = new System.Windows.Forms.Label();
            this.buttonFont = new System.Windows.Forms.Button();
            this.textBoxImageIndex = new System.Windows.Forms.TextBox();
            this.label9 = new System.Windows.Forms.Label();
            this.textBoxText = new System.Windows.Forms.TextBox();
            this.label13 = new System.Windows.Forms.Label();
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.tabControl1.SuspendLayout();
            this.tabPage1.SuspendLayout();
            this.tabPage4.SuspendLayout();
            this.tabPage2.SuspendLayout();
            this.tabPage3.SuspendLayout();
            this.SuspendLayout();
            // 
            // tabControl1
            // 
            this.tabControl1.Controls.Add(this.tabPage1);
            this.tabControl1.Controls.Add(this.tabPage4);
            this.tabControl1.Controls.Add(this.tabPage2);
            this.tabControl1.Controls.Add(this.tabPage3);
            this.tabControl1.Location = new System.Drawing.Point(8, 16);
            this.tabControl1.Name = "tabControl1";
            this.tabControl1.SelectedIndex = 0;
            this.tabControl1.Size = new System.Drawing.Size(455, 280);
            this.tabControl1.TabIndex = 0;
            // 
            // tabPage1
            // 
            this.tabPage1.Controls.Add(this.label19);
            this.tabPage1.Controls.Add(this.comboBoxDock);
            this.tabPage1.Controls.Add(this.label18);
            this.tabPage1.Controls.Add(this.comboBoxAttachmentStyle);
            this.tabPage1.Controls.Add(this.comboBoxGradientMode);
            this.tabPage1.Controls.Add(this.label15);
            this.tabPage1.Controls.Add(this.comboBoxTrimming);
            this.tabPage1.Controls.Add(this.label14);
            this.tabPage1.Controls.Add(this.label12);
            this.tabPage1.Controls.Add(this.label11);
            this.tabPage1.Controls.Add(this.label10);
            this.tabPage1.Controls.Add(this.comboBoxYTextMargin);
            this.tabPage1.Controls.Add(this.comboBoxXTextMargin);
            this.tabPage1.Controls.Add(this.comboBoxAutoSize);
            this.tabPage1.Controls.Add(this.label8);
            this.tabPage1.Controls.Add(this.comboBoxShadow);
            this.tabPage1.Controls.Add(this.label7);
            this.tabPage1.Controls.Add(this.comboBoxAlignment);
            this.tabPage1.Controls.Add(this.label6);
            this.tabPage1.Controls.Add(this.comboBoxImagePosition);
            this.tabPage1.Controls.Add(this.label5);
            this.tabPage1.Controls.Add(this.comboBoxShapeOrientation);
            this.tabPage1.Controls.Add(this.label4);
            this.tabPage1.Controls.Add(this.comboBoxPenWidth);
            this.tabPage1.Controls.Add(this.label3);
            this.tabPage1.Controls.Add(this.comboBoxDashStyle);
            this.tabPage1.Controls.Add(this.label2);
            this.tabPage1.Controls.Add(this.comboBoxShape);
            this.tabPage1.Controls.Add(this.label1);
            this.tabPage1.Location = new System.Drawing.Point(4, 22);
            this.tabPage1.Name = "tabPage1";
            this.tabPage1.Size = new System.Drawing.Size(447, 254);
            this.tabPage1.TabIndex = 0;
            this.tabPage1.Text = "Styles";
            // 
            // label19
            // 
            this.label19.AutoSize = true;
            this.label19.Location = new System.Drawing.Point(292, 48);
            this.label19.Name = "label19";
            this.label19.Size = new System.Drawing.Size(33, 13);
            this.label19.TabIndex = 28;
            this.label19.Text = "Dock";
            // 
            // comboBoxDock
            // 
            this.comboBoxDock.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxDock.Location = new System.Drawing.Point(295, 64);
            this.comboBoxDock.Name = "comboBoxDock";
            this.comboBoxDock.Size = new System.Drawing.Size(136, 21);
            this.comboBoxDock.TabIndex = 27;
            // 
            // label18
            // 
            this.label18.AutoSize = true;
            this.label18.Location = new System.Drawing.Point(292, 8);
            this.label18.Name = "label18";
            this.label18.Size = new System.Drawing.Size(84, 13);
            this.label18.TabIndex = 26;
            this.label18.Text = "AttachmentStyle";
            // 
            // comboBoxAttachmentStyle
            // 
            this.comboBoxAttachmentStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxAttachmentStyle.Location = new System.Drawing.Point(295, 24);
            this.comboBoxAttachmentStyle.Name = "comboBoxAttachmentStyle";
            this.comboBoxAttachmentStyle.Size = new System.Drawing.Size(136, 21);
            this.comboBoxAttachmentStyle.TabIndex = 25;
            // 
            // comboBoxGradientMode
            // 
            this.comboBoxGradientMode.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxGradientMode.Location = new System.Drawing.Point(150, 224);
            this.comboBoxGradientMode.Name = "comboBoxGradientMode";
            this.comboBoxGradientMode.Size = new System.Drawing.Size(136, 21);
            this.comboBoxGradientMode.TabIndex = 24;
            // 
            // label15
            // 
            this.label15.AutoSize = true;
            this.label15.Location = new System.Drawing.Point(150, 208);
            this.label15.Name = "label15";
            this.label15.Size = new System.Drawing.Size(77, 13);
            this.label15.TabIndex = 23;
            this.label15.Text = "Gradient Mode";
            // 
            // comboBoxTrimming
            // 
            this.comboBoxTrimming.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxTrimming.Location = new System.Drawing.Point(150, 184);
            this.comboBoxTrimming.Name = "comboBoxTrimming";
            this.comboBoxTrimming.Size = new System.Drawing.Size(136, 21);
            this.comboBoxTrimming.TabIndex = 22;
            // 
            // label14
            // 
            this.label14.AutoSize = true;
            this.label14.Location = new System.Drawing.Point(150, 168);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(49, 13);
            this.label14.TabIndex = 21;
            this.label14.Text = "Trimming";
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Location = new System.Drawing.Point(8, 208);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(14, 13);
            this.label12.TabIndex = 20;
            this.label12.Text = "Y";
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(8, 184);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(14, 13);
            this.label11.TabIndex = 19;
            this.label11.Text = "X";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(8, 168);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(65, 13);
            this.label10.TabIndex = 18;
            this.label10.Text = "TextMargins";
            // 
            // comboBoxYTextMargin
            // 
            this.comboBoxYTextMargin.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxYTextMargin.Location = new System.Drawing.Point(24, 208);
            this.comboBoxYTextMargin.Name = "comboBoxYTextMargin";
            this.comboBoxYTextMargin.Size = new System.Drawing.Size(48, 21);
            this.comboBoxYTextMargin.TabIndex = 17;
            // 
            // comboBoxXTextMargin
            // 
            this.comboBoxXTextMargin.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxXTextMargin.Location = new System.Drawing.Point(24, 184);
            this.comboBoxXTextMargin.Name = "comboBoxXTextMargin";
            this.comboBoxXTextMargin.Size = new System.Drawing.Size(48, 21);
            this.comboBoxXTextMargin.TabIndex = 16;
            // 
            // comboBoxAutoSize
            // 
            this.comboBoxAutoSize.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxAutoSize.Location = new System.Drawing.Point(150, 104);
            this.comboBoxAutoSize.Name = "comboBoxAutoSize";
            this.comboBoxAutoSize.Size = new System.Drawing.Size(136, 21);
            this.comboBoxAutoSize.TabIndex = 15;
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(150, 88);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(49, 13);
            this.label8.TabIndex = 14;
            this.label8.Text = "AutoSize";
            // 
            // comboBoxShadow
            // 
            this.comboBoxShadow.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxShadow.Location = new System.Drawing.Point(150, 144);
            this.comboBoxShadow.Name = "comboBoxShadow";
            this.comboBoxShadow.Size = new System.Drawing.Size(136, 21);
            this.comboBoxShadow.TabIndex = 13;
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(150, 128);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(46, 13);
            this.label7.TabIndex = 12;
            this.label7.Text = "Shadow";
            // 
            // comboBoxAlignment
            // 
            this.comboBoxAlignment.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxAlignment.Location = new System.Drawing.Point(8, 104);
            this.comboBoxAlignment.Name = "comboBoxAlignment";
            this.comboBoxAlignment.Size = new System.Drawing.Size(136, 21);
            this.comboBoxAlignment.TabIndex = 11;
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(8, 88);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(53, 13);
            this.label6.TabIndex = 10;
            this.label6.Text = "Alignment";
            // 
            // comboBoxImagePosition
            // 
            this.comboBoxImagePosition.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxImagePosition.Location = new System.Drawing.Point(8, 144);
            this.comboBoxImagePosition.Name = "comboBoxImagePosition";
            this.comboBoxImagePosition.Size = new System.Drawing.Size(136, 21);
            this.comboBoxImagePosition.TabIndex = 9;
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(8, 128);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(77, 13);
            this.label5.TabIndex = 8;
            this.label5.Text = "PicturePosition";
            // 
            // comboBoxShapeOrientation
            // 
            this.comboBoxShapeOrientation.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxShapeOrientation.Location = new System.Drawing.Point(150, 24);
            this.comboBoxShapeOrientation.Name = "comboBoxShapeOrientation";
            this.comboBoxShapeOrientation.Size = new System.Drawing.Size(136, 21);
            this.comboBoxShapeOrientation.TabIndex = 7;
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(150, 8);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(92, 13);
            this.label4.TabIndex = 6;
            this.label4.Text = "Shape Orientation";
            // 
            // comboBoxPenWidth
            // 
            this.comboBoxPenWidth.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxPenWidth.Location = new System.Drawing.Point(150, 64);
            this.comboBoxPenWidth.Name = "comboBoxPenWidth";
            this.comboBoxPenWidth.Size = new System.Drawing.Size(56, 21);
            this.comboBoxPenWidth.TabIndex = 5;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(150, 48);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(54, 13);
            this.label3.TabIndex = 4;
            this.label3.Text = "PenWidth";
            // 
            // comboBoxDashStyle
            // 
            this.comboBoxDashStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxDashStyle.Location = new System.Drawing.Point(8, 64);
            this.comboBoxDashStyle.Name = "comboBoxDashStyle";
            this.comboBoxDashStyle.Size = new System.Drawing.Size(136, 21);
            this.comboBoxDashStyle.TabIndex = 3;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(8, 48);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(55, 13);
            this.label2.TabIndex = 2;
            this.label2.Text = "DashStyle";
            // 
            // comboBoxShape
            // 
            this.comboBoxShape.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxShape.Location = new System.Drawing.Point(8, 24);
            this.comboBoxShape.Name = "comboBoxShape";
            this.comboBoxShape.Size = new System.Drawing.Size(136, 21);
            this.comboBoxShape.TabIndex = 1;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(8, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(64, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "Shape Style";
            // 
            // tabPage4
            // 
            this.tabPage4.Controls.Add(this.buttonGradientColor);
            this.tabPage4.Controls.Add(this.labelGradientColor);
            this.tabPage4.Controls.Add(this.buttonShadowColor);
            this.tabPage4.Controls.Add(this.labelShadowColor);
            this.tabPage4.Controls.Add(this.buttonTextColor);
            this.tabPage4.Controls.Add(this.buttonDrawColor);
            this.tabPage4.Controls.Add(this.buttonFillColor);
            this.tabPage4.Controls.Add(this.labelTextColor);
            this.tabPage4.Controls.Add(this.labelDrawColor);
            this.tabPage4.Controls.Add(this.labelFillColor);
            this.tabPage4.Location = new System.Drawing.Point(4, 22);
            this.tabPage4.Name = "tabPage4";
            this.tabPage4.Size = new System.Drawing.Size(447, 254);
            this.tabPage4.TabIndex = 3;
            this.tabPage4.Text = "Colors";
            // 
            // buttonGradientColor
            // 
            this.buttonGradientColor.Location = new System.Drawing.Point(16, 176);
            this.buttonGradientColor.Name = "buttonGradientColor";
            this.buttonGradientColor.Size = new System.Drawing.Size(96, 24);
            this.buttonGradientColor.TabIndex = 9;
            this.buttonGradientColor.Text = "Gradient Color...";
            this.buttonGradientColor.Click += new System.EventHandler(this.buttonGradientColor_Click);
            // 
            // labelGradientColor
            // 
            this.labelGradientColor.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.labelGradientColor.Location = new System.Drawing.Point(128, 176);
            this.labelGradientColor.Name = "labelGradientColor";
            this.labelGradientColor.Size = new System.Drawing.Size(40, 24);
            this.labelGradientColor.TabIndex = 8;
            // 
            // buttonShadowColor
            // 
            this.buttonShadowColor.Location = new System.Drawing.Point(16, 136);
            this.buttonShadowColor.Name = "buttonShadowColor";
            this.buttonShadowColor.Size = new System.Drawing.Size(96, 24);
            this.buttonShadowColor.TabIndex = 7;
            this.buttonShadowColor.Text = "Shadow Color...";
            this.buttonShadowColor.Click += new System.EventHandler(this.buttonShadowColor_Click);
            // 
            // labelShadowColor
            // 
            this.labelShadowColor.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.labelShadowColor.Location = new System.Drawing.Point(128, 136);
            this.labelShadowColor.Name = "labelShadowColor";
            this.labelShadowColor.Size = new System.Drawing.Size(40, 24);
            this.labelShadowColor.TabIndex = 6;
            // 
            // buttonTextColor
            // 
            this.buttonTextColor.Location = new System.Drawing.Point(16, 96);
            this.buttonTextColor.Name = "buttonTextColor";
            this.buttonTextColor.Size = new System.Drawing.Size(96, 24);
            this.buttonTextColor.TabIndex = 5;
            this.buttonTextColor.Text = "Text Color...";
            this.buttonTextColor.Click += new System.EventHandler(this.buttonTextColor_Click);
            // 
            // buttonDrawColor
            // 
            this.buttonDrawColor.Location = new System.Drawing.Point(16, 56);
            this.buttonDrawColor.Name = "buttonDrawColor";
            this.buttonDrawColor.Size = new System.Drawing.Size(96, 24);
            this.buttonDrawColor.TabIndex = 4;
            this.buttonDrawColor.Text = "Draw Color...";
            this.buttonDrawColor.Click += new System.EventHandler(this.buttonDrawColor_Click);
            // 
            // buttonFillColor
            // 
            this.buttonFillColor.Location = new System.Drawing.Point(16, 16);
            this.buttonFillColor.Name = "buttonFillColor";
            this.buttonFillColor.Size = new System.Drawing.Size(96, 24);
            this.buttonFillColor.TabIndex = 3;
            this.buttonFillColor.Text = "Fill Color...";
            this.buttonFillColor.Click += new System.EventHandler(this.buttonFillColor_Click);
            // 
            // labelTextColor
            // 
            this.labelTextColor.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.labelTextColor.Location = new System.Drawing.Point(128, 96);
            this.labelTextColor.Name = "labelTextColor";
            this.labelTextColor.Size = new System.Drawing.Size(40, 24);
            this.labelTextColor.TabIndex = 2;
            // 
            // labelDrawColor
            // 
            this.labelDrawColor.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.labelDrawColor.Location = new System.Drawing.Point(128, 56);
            this.labelDrawColor.Name = "labelDrawColor";
            this.labelDrawColor.Size = new System.Drawing.Size(40, 24);
            this.labelDrawColor.TabIndex = 1;
            // 
            // labelFillColor
            // 
            this.labelFillColor.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.labelFillColor.Location = new System.Drawing.Point(128, 16);
            this.labelFillColor.Name = "labelFillColor";
            this.labelFillColor.Size = new System.Drawing.Size(40, 24);
            this.labelFillColor.TabIndex = 0;
            // 
            // tabPage2
            // 
            this.tabPage2.Controls.Add(this.checkBoxRemoveChildren);
            this.tabPage2.Controls.Add(this.checkBoxHighlightChildren);
            this.tabPage2.Controls.Add(this.checkBoxGradient);
            this.tabPage2.Controls.Add(this.checkBoxOutLinkable);
            this.tabPage2.Controls.Add(this.checkBoxInLinkable);
            this.tabPage2.Controls.Add(this.checkBoxLabelEdit);
            this.tabPage2.Controls.Add(this.checkBoxOwnerDraw);
            this.tabPage2.Controls.Add(this.checkBoxYSizeable);
            this.tabPage2.Controls.Add(this.checkBoxXSizeable);
            this.tabPage2.Controls.Add(this.checkBoxYMoveable);
            this.tabPage2.Controls.Add(this.checkBoxXMoveable);
            this.tabPage2.Controls.Add(this.checkBoxLogical);
            this.tabPage2.Controls.Add(this.checkBoxSelectable);
            this.tabPage2.Controls.Add(this.checkBoxHidden);
            this.tabPage2.Controls.Add(this.checkBoxTransparent);
            this.tabPage2.Location = new System.Drawing.Point(4, 22);
            this.tabPage2.Name = "tabPage2";
            this.tabPage2.Size = new System.Drawing.Size(447, 254);
            this.tabPage2.TabIndex = 1;
            this.tabPage2.Text = "Flags";
            // 
            // checkBoxRemoveChildren
            // 
            this.checkBoxRemoveChildren.Location = new System.Drawing.Point(304, 56);
            this.checkBoxRemoveChildren.Name = "checkBoxRemoveChildren";
            this.checkBoxRemoveChildren.Size = new System.Drawing.Size(120, 24);
            this.checkBoxRemoveChildren.TabIndex = 14;
            this.checkBoxRemoveChildren.Text = "RemoveChildren";
            // 
            // checkBoxHighlightChildren
            // 
            this.checkBoxHighlightChildren.Location = new System.Drawing.Point(304, 24);
            this.checkBoxHighlightChildren.Name = "checkBoxHighlightChildren";
            this.checkBoxHighlightChildren.Size = new System.Drawing.Size(120, 24);
            this.checkBoxHighlightChildren.TabIndex = 13;
            this.checkBoxHighlightChildren.Text = "HighlightChildren";
            // 
            // checkBoxGradient
            // 
            this.checkBoxGradient.Location = new System.Drawing.Point(40, 216);
            this.checkBoxGradient.Name = "checkBoxGradient";
            this.checkBoxGradient.Size = new System.Drawing.Size(88, 24);
            this.checkBoxGradient.TabIndex = 6;
            this.checkBoxGradient.Text = "Gradient";
            // 
            // checkBoxOutLinkable
            // 
            this.checkBoxOutLinkable.Location = new System.Drawing.Point(176, 184);
            this.checkBoxOutLinkable.Name = "checkBoxOutLinkable";
            this.checkBoxOutLinkable.Size = new System.Drawing.Size(88, 24);
            this.checkBoxOutLinkable.TabIndex = 12;
            this.checkBoxOutLinkable.Text = "OutLinkable";
            // 
            // checkBoxInLinkable
            // 
            this.checkBoxInLinkable.Location = new System.Drawing.Point(176, 152);
            this.checkBoxInLinkable.Name = "checkBoxInLinkable";
            this.checkBoxInLinkable.Size = new System.Drawing.Size(88, 24);
            this.checkBoxInLinkable.TabIndex = 11;
            this.checkBoxInLinkable.Text = "InLinkable";
            // 
            // checkBoxLabelEdit
            // 
            this.checkBoxLabelEdit.Location = new System.Drawing.Point(40, 56);
            this.checkBoxLabelEdit.Name = "checkBoxLabelEdit";
            this.checkBoxLabelEdit.Size = new System.Drawing.Size(88, 24);
            this.checkBoxLabelEdit.TabIndex = 1;
            this.checkBoxLabelEdit.Text = "LabelEdit";
            // 
            // checkBoxOwnerDraw
            // 
            this.checkBoxOwnerDraw.Location = new System.Drawing.Point(40, 120);
            this.checkBoxOwnerDraw.Name = "checkBoxOwnerDraw";
            this.checkBoxOwnerDraw.Size = new System.Drawing.Size(88, 24);
            this.checkBoxOwnerDraw.TabIndex = 3;
            this.checkBoxOwnerDraw.Text = "OwnerDraw";
            // 
            // checkBoxYSizeable
            // 
            this.checkBoxYSizeable.Location = new System.Drawing.Point(176, 120);
            this.checkBoxYSizeable.Name = "checkBoxYSizeable";
            this.checkBoxYSizeable.Size = new System.Drawing.Size(88, 24);
            this.checkBoxYSizeable.TabIndex = 10;
            this.checkBoxYSizeable.Text = "YSizeable";
            // 
            // checkBoxXSizeable
            // 
            this.checkBoxXSizeable.Location = new System.Drawing.Point(176, 88);
            this.checkBoxXSizeable.Name = "checkBoxXSizeable";
            this.checkBoxXSizeable.Size = new System.Drawing.Size(88, 24);
            this.checkBoxXSizeable.TabIndex = 9;
            this.checkBoxXSizeable.Text = "XSizeable";
            // 
            // checkBoxYMoveable
            // 
            this.checkBoxYMoveable.Location = new System.Drawing.Point(176, 56);
            this.checkBoxYMoveable.Name = "checkBoxYMoveable";
            this.checkBoxYMoveable.Size = new System.Drawing.Size(88, 24);
            this.checkBoxYMoveable.TabIndex = 8;
            this.checkBoxYMoveable.Text = "YMoveable";
            // 
            // checkBoxXMoveable
            // 
            this.checkBoxXMoveable.Location = new System.Drawing.Point(176, 24);
            this.checkBoxXMoveable.Name = "checkBoxXMoveable";
            this.checkBoxXMoveable.Size = new System.Drawing.Size(88, 24);
            this.checkBoxXMoveable.TabIndex = 7;
            this.checkBoxXMoveable.Text = "XMoveable";
            // 
            // checkBoxLogical
            // 
            this.checkBoxLogical.Location = new System.Drawing.Point(40, 88);
            this.checkBoxLogical.Name = "checkBoxLogical";
            this.checkBoxLogical.Size = new System.Drawing.Size(88, 24);
            this.checkBoxLogical.TabIndex = 2;
            this.checkBoxLogical.Text = "Logical";
            // 
            // checkBoxSelectable
            // 
            this.checkBoxSelectable.Location = new System.Drawing.Point(40, 152);
            this.checkBoxSelectable.Name = "checkBoxSelectable";
            this.checkBoxSelectable.Size = new System.Drawing.Size(88, 24);
            this.checkBoxSelectable.TabIndex = 4;
            this.checkBoxSelectable.Text = "Selectable";
            // 
            // checkBoxHidden
            // 
            this.checkBoxHidden.Location = new System.Drawing.Point(40, 24);
            this.checkBoxHidden.Name = "checkBoxHidden";
            this.checkBoxHidden.Size = new System.Drawing.Size(88, 24);
            this.checkBoxHidden.TabIndex = 0;
            this.checkBoxHidden.Text = "Hidden";
            // 
            // checkBoxTransparent
            // 
            this.checkBoxTransparent.Location = new System.Drawing.Point(40, 184);
            this.checkBoxTransparent.Name = "checkBoxTransparent";
            this.checkBoxTransparent.Size = new System.Drawing.Size(88, 24);
            this.checkBoxTransparent.TabIndex = 5;
            this.checkBoxTransparent.Text = "Transparent";
            // 
            // tabPage3
            // 
            this.tabPage3.Controls.Add(this.textBoxUrl);
            this.tabPage3.Controls.Add(this.label17);
            this.tabPage3.Controls.Add(this.textBoxTooltip);
            this.tabPage3.Controls.Add(this.label16);
            this.tabPage3.Controls.Add(this.buttonFont);
            this.tabPage3.Controls.Add(this.textBoxImageIndex);
            this.tabPage3.Controls.Add(this.label9);
            this.tabPage3.Controls.Add(this.textBoxText);
            this.tabPage3.Controls.Add(this.label13);
            this.tabPage3.Location = new System.Drawing.Point(4, 22);
            this.tabPage3.Name = "tabPage3";
            this.tabPage3.Size = new System.Drawing.Size(447, 254);
            this.tabPage3.TabIndex = 2;
            this.tabPage3.Text = "Text, Font and Image";
            // 
            // textBoxUrl
            // 
            this.textBoxUrl.Location = new System.Drawing.Point(16, 224);
            this.textBoxUrl.Name = "textBoxUrl";
            this.textBoxUrl.Size = new System.Drawing.Size(264, 20);
            this.textBoxUrl.TabIndex = 8;
            // 
            // label17
            // 
            this.label17.AutoSize = true;
            this.label17.Location = new System.Drawing.Point(16, 208);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(20, 13);
            this.label17.TabIndex = 7;
            this.label17.Text = "Url";
            // 
            // textBoxTooltip
            // 
            this.textBoxTooltip.Location = new System.Drawing.Point(16, 160);
            this.textBoxTooltip.Multiline = true;
            this.textBoxTooltip.Name = "textBoxTooltip";
            this.textBoxTooltip.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.textBoxTooltip.Size = new System.Drawing.Size(264, 40);
            this.textBoxTooltip.TabIndex = 6;
            // 
            // label16
            // 
            this.label16.AutoSize = true;
            this.label16.Location = new System.Drawing.Point(16, 144);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(39, 13);
            this.label16.TabIndex = 5;
            this.label16.Text = "Tooltip";
            // 
            // buttonFont
            // 
            this.buttonFont.Location = new System.Drawing.Point(296, 32);
            this.buttonFont.Name = "buttonFont";
            this.buttonFont.Size = new System.Drawing.Size(56, 24);
            this.buttonFont.TabIndex = 4;
            this.buttonFont.Text = "Font...";
            this.buttonFont.Click += new System.EventHandler(this.buttonFont_Click);
            // 
            // textBoxImageIndex
            // 
            this.textBoxImageIndex.Location = new System.Drawing.Point(16, 112);
            this.textBoxImageIndex.Name = "textBoxImageIndex";
            this.textBoxImageIndex.Size = new System.Drawing.Size(56, 20);
            this.textBoxImageIndex.TabIndex = 2;
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(16, 96);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(62, 13);
            this.label9.TabIndex = 1;
            this.label9.Text = "ImageIndex";
            // 
            // textBoxText
            // 
            this.textBoxText.Location = new System.Drawing.Point(16, 32);
            this.textBoxText.Multiline = true;
            this.textBoxText.Name = "textBoxText";
            this.textBoxText.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.textBoxText.Size = new System.Drawing.Size(264, 56);
            this.textBoxText.TabIndex = 0;
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Location = new System.Drawing.Point(16, 16);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(28, 13);
            this.label13.TabIndex = 0;
            this.label13.Text = "Text";
            // 
            // button1
            // 
            this.button1.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.button1.Location = new System.Drawing.Point(296, 302);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(80, 24);
            this.button1.TabIndex = 1;
            this.button1.Text = "OK";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.button2.Location = new System.Drawing.Point(384, 302);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(75, 23);
            this.button2.TabIndex = 2;
            this.button2.Text = "Cancel";
            // 
            // NodePropertyPage
            // 
            this.ClientSize = new System.Drawing.Size(478, 335);
            this.ControlBox = false;
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.tabControl1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "NodePropertyPage";
            this.ShowInTaskbar = false;
            this.Text = "Node properties";
            this.Load += new System.EventHandler(this.NodePropertyPage_Load);
            this.tabControl1.ResumeLayout(false);
            this.tabPage1.ResumeLayout(false);
            this.tabPage1.PerformLayout();
            this.tabPage4.ResumeLayout(false);
            this.tabPage2.ResumeLayout(false);
            this.tabPage3.ResumeLayout(false);
            this.tabPage3.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion
        
        public Node Node
        {
            get { return m_node; }
            set { m_node = value; }
        }

        /// <summary>Returns/sets the reference to the AddFlow object</summary>
        public AddFlow AddFlow
        {
            get { return m_addflow; }
            set { m_addflow = value; }
        }

        private void NodePropertyPage_Load(object sender, System.EventArgs e)
        {
            // Fill the combo boxes
            foreach (ShapeStyle v in Enum.GetValues(typeof(ShapeStyle)))
                comboBoxShape.Items.Add(v.ToString());
            foreach (ShapeOrientation v in Enum.GetValues(typeof(ShapeOrientation)))
                comboBoxShapeOrientation.Items.Add(v.ToString());
            foreach (DashStyle v in Enum.GetValues(typeof(DashStyle)))
                comboBoxDashStyle.Items.Add(v.ToString());
            for (int i = 0; i <= 16; i++)
                comboBoxPenWidth.Items.Add(i);
            foreach (ImagePosition v in Enum.GetValues(typeof(ImagePosition)))
                comboBoxImagePosition.Items.Add(v.ToString());
            foreach (Alignment v in Enum.GetValues(typeof(Alignment)))
                comboBoxAlignment.Items.Add(v.ToString());
            foreach (AutoSize v in Enum.GetValues(typeof(AutoSize)))
                comboBoxAutoSize.Items.Add(v.ToString());
            foreach (ShadowStyle v in Enum.GetValues(typeof(ShadowStyle)))
                comboBoxShadow.Items.Add(v.ToString());
            for (int i = 0; i <= 50; i++)
                comboBoxXTextMargin.Items.Add(i + "%");
            for (int i = 0; i <= 50; i++)
                comboBoxYTextMargin.Items.Add(i + "%");
            foreach (StringTrimming v in Enum.GetValues(typeof(StringTrimming)))
				comboBoxTrimming.Items.Add(v.ToString());
			foreach (LinearGradientMode v in Enum.GetValues(typeof(LinearGradientMode)))
                comboBoxGradientMode.Items.Add(v.ToString());
            foreach (AttachmentStyle v in Enum.GetValues(typeof(AttachmentStyle)))
                comboBoxAttachmentStyle.Items.Add(v.ToString());
            foreach (DockStyle v in Enum.GetValues(typeof(DockStyle)))
                comboBoxDock.Items.Add(v.ToString());

            if (m_node != null)
            {
                comboBoxShape.SelectedItem = m_node.Shape.Style.ToString();
                comboBoxShapeOrientation.SelectedItem = m_node.Shape.Orientation.ToString();
                comboBoxDashStyle.SelectedItem = m_node.DashStyle.ToString();
                comboBoxPenWidth.SelectedItem = m_node.DrawWidth;                        
                comboBoxImagePosition.SelectedItem = m_node.ImagePosition.ToString();            
                comboBoxAlignment.SelectedItem = m_node.Alignment.ToString();
                comboBoxAutoSize.SelectedItem = m_node.AutoSize.ToString();            
                comboBoxShadow.SelectedItem = m_node.Shadow.Style.ToString();                            
                comboBoxXTextMargin.SelectedItem = m_node.TextMargin.Width + "%";
                comboBoxYTextMargin.SelectedItem = m_node.TextMargin.Height + "%";
				comboBoxTrimming.SelectedItem = m_node.Trimming.ToString();
                comboBoxGradientMode.SelectedItem = m_node.GradientMode.ToString();
                comboBoxAttachmentStyle.SelectedItem = m_node.AttachmentStyle.ToString();
                comboBoxDock.SelectedItem = m_node.Dock.ToString();
				checkBoxTransparent.Checked = m_node.Transparent;
				checkBoxGradient.Checked = m_node.Gradient;
                checkBoxHidden.Checked = m_node.Hidden;
                checkBoxOwnerDraw.Checked = m_node.OwnerDraw;
                checkBoxLogical.Checked = m_node.Logical;
                checkBoxSelectable.Checked = m_node.Selectable;
                checkBoxXMoveable.Checked = m_node.XMoveable;
                checkBoxYMoveable.Checked = m_node.YMoveable;
                checkBoxXSizeable.Checked = m_node.XSizeable;
				checkBoxYSizeable.Checked = m_node.YSizeable;
				checkBoxInLinkable.Checked = m_node.InLinkable;
				checkBoxOutLinkable.Checked = m_node.OutLinkable;
                checkBoxLabelEdit.Checked = m_node.LabelEdit;
                checkBoxHighlightChildren.Checked = m_node.HighlightChildren;
                checkBoxRemoveChildren.Checked = m_node.RemoveChildren;
				textBoxText.Text = m_node.Text;
				textBoxTooltip.Text = m_node.Tooltip;
				textBoxUrl.Text = m_node.Url;
                textBoxImageIndex.Text = m_node.ImageIndex.ToString();         
                labelFillColor.BackColor = m_node.FillColor;
                labelDrawColor.BackColor = m_node.DrawColor;
                labelTextColor.BackColor = m_node.TextColor;
				labelShadowColor.BackColor = m_node.Shadow.Color;
				labelGradientColor.BackColor = m_node.GradientColor;
                textBoxText.Font = m_node.Font;
            }
            else
            {
                comboBoxShape.SelectedItem = m_addflow.DefNodeProp.Shape.Style.ToString();
                comboBoxShapeOrientation.SelectedItem = m_addflow.DefNodeProp.Shape.Orientation.ToString();
                comboBoxDashStyle.SelectedItem = m_addflow.DefNodeProp.DashStyle.ToString();
                comboBoxPenWidth.SelectedItem = m_addflow.DefNodeProp.DrawWidth;                        
                comboBoxImagePosition.SelectedItem = m_addflow.DefNodeProp.ImagePosition.ToString();            
                comboBoxAlignment.SelectedItem = m_addflow.DefNodeProp.Alignment.ToString();
                comboBoxAutoSize.SelectedItem = m_addflow.DefNodeProp.AutoSize.ToString();            
                comboBoxShadow.SelectedItem = m_addflow.DefNodeProp.Shadow.Style.ToString();                            
                comboBoxXTextMargin.SelectedItem = m_addflow.DefNodeProp.TextMargin.Width + "%";
                comboBoxYTextMargin.SelectedItem = m_addflow.DefNodeProp.TextMargin.Height + "%";
				comboBoxTrimming.SelectedItem = m_addflow.DefNodeProp.Trimming.ToString();
                comboBoxGradientMode.SelectedItem = m_addflow.DefNodeProp.GradientMode.ToString();
                comboBoxAttachmentStyle.SelectedItem = m_addflow.DefNodeProp.AttachmentStyle.ToString();
                comboBoxDock.SelectedItem = m_addflow.DefNodeProp.Dock.ToString();
				checkBoxTransparent.Checked = m_addflow.DefNodeProp.Transparent;
				checkBoxGradient.Checked = m_addflow.DefNodeProp.Gradient;
                checkBoxHidden.Checked = m_addflow.DefNodeProp.Hidden;
                checkBoxOwnerDraw.Checked = m_addflow.DefNodeProp.OwnerDraw;
                checkBoxLogical.Checked = m_addflow.DefNodeProp.Logical;
                checkBoxSelectable.Checked = m_addflow.DefNodeProp.Selectable;
                checkBoxXMoveable.Checked = m_addflow.DefNodeProp.XMoveable;
                checkBoxYMoveable.Checked = m_addflow.DefNodeProp.YMoveable;
                checkBoxXSizeable.Checked = m_addflow.DefNodeProp.XSizeable;
				checkBoxYSizeable.Checked = m_addflow.DefNodeProp.YSizeable;
				checkBoxInLinkable.Checked = m_addflow.DefNodeProp.InLinkable;
				checkBoxOutLinkable.Checked = m_addflow.DefNodeProp.OutLinkable;
                checkBoxLabelEdit.Checked = m_addflow.DefNodeProp.LabelEdit;
                checkBoxHighlightChildren.Checked = m_addflow.DefNodeProp.HighlightChildren;
                checkBoxRemoveChildren.Checked = m_addflow.DefNodeProp.RemoveChildren;
				textBoxText.Text = m_addflow.DefNodeProp.Text;
				textBoxTooltip.Text = m_addflow.DefNodeProp.Tooltip;
				textBoxUrl.Text = m_addflow.DefNodeProp.Url;
                textBoxImageIndex.Text = m_addflow.DefNodeProp.ImageIndex.ToString();         
                labelFillColor.BackColor = m_addflow.DefNodeProp.FillColor;
                labelDrawColor.BackColor = m_addflow.DefNodeProp.DrawColor;
                labelTextColor.BackColor = m_addflow.DefNodeProp.TextColor;
				labelShadowColor.BackColor = m_addflow.DefNodeProp.Shadow.Color;
				labelGradientColor.BackColor = m_addflow.DefNodeProp.GradientColor;
                textBoxText.Font = m_addflow.DefNodeProp.Font;
            }
        }

        private void button1_Click(object sender, System.EventArgs e)
        {
            ShapeStyle shapestyle = (ShapeStyle)comboBoxShape.SelectedIndex;
            ShapeOrientation shapeorientation = 
                               (ShapeOrientation)comboBoxShapeOrientation.SelectedIndex;
            ShadowStyle shadowstyle = (ShadowStyle)comboBoxShadow.SelectedIndex;
            Color shadowcolor = labelShadowColor.BackColor;

            if (m_node != null)
            {
                if (m_node.Shape.Orientation != shapeorientation || 
                    m_node.Shape.Style != shapestyle)
                    m_node.Shape = new Shape(shapestyle, shapeorientation);
                if (m_node.Shadow.Style != shadowstyle || m_node.Shadow.Color != shadowcolor)
                {
                    m_node.Shadow.Style = shadowstyle;
                    m_node.Shadow.Color = shadowcolor;
                }

                if (m_node.DashStyle != (DashStyle)comboBoxDashStyle.SelectedIndex)
                    m_node.DashStyle = (DashStyle)comboBoxDashStyle.SelectedIndex;
                if (m_node.DrawWidth != comboBoxPenWidth.SelectedIndex)
                    m_node.DrawWidth = comboBoxPenWidth.SelectedIndex;
                if (m_node.ImagePosition != (ImagePosition)comboBoxImagePosition.SelectedIndex)
                    m_node.ImagePosition = (ImagePosition)comboBoxImagePosition.SelectedIndex;
                if (m_node.Alignment != (Alignment)comboBoxAlignment.SelectedIndex)
                    m_node.Alignment = (Alignment)comboBoxAlignment.SelectedIndex;
                if (m_node.AutoSize != (AutoSize)comboBoxAutoSize.SelectedIndex)
                    m_node.AutoSize = (AutoSize)comboBoxAutoSize.SelectedIndex;
                if (m_node.AttachmentStyle != (AttachmentStyle)comboBoxAttachmentStyle.SelectedIndex)
                    m_node.AttachmentStyle = (AttachmentStyle)comboBoxAttachmentStyle.SelectedIndex;
                if (m_node.Dock != (DockStyle)comboBoxDock.SelectedIndex)
                    m_node.Dock = (DockStyle)comboBoxDock.SelectedIndex;
            
                Size sizeMargin = new Size(comboBoxXTextMargin.SelectedIndex, 
                    comboBoxYTextMargin.SelectedIndex);
                if (!m_node.TextMargin.Equals(sizeMargin))
                    m_node.TextMargin = sizeMargin;

                if (m_node.Trimming != (StringTrimming)comboBoxTrimming.SelectedIndex)
					m_node.Trimming = (StringTrimming)comboBoxTrimming.SelectedIndex;
				if (m_node.GradientMode != (LinearGradientMode)comboBoxGradientMode.SelectedIndex)
					m_node.GradientMode = (LinearGradientMode)comboBoxGradientMode.SelectedIndex;

                if (m_node.LabelEdit != checkBoxLabelEdit.Checked)
                    m_node.LabelEdit = checkBoxLabelEdit.Checked;
                if (m_node.Transparent != checkBoxTransparent.Checked)
					m_node.Transparent = checkBoxTransparent.Checked;
				if (m_node.Gradient != checkBoxGradient.Checked)
					m_node.Gradient = checkBoxGradient.Checked;
                if (m_node.Hidden != checkBoxHidden.Checked)
                    m_node.Hidden = checkBoxHidden.Checked;
                if (m_node.OwnerDraw != checkBoxOwnerDraw.Checked)
                    m_node.OwnerDraw = checkBoxOwnerDraw.Checked;
                if (m_node.Logical != checkBoxLogical.Checked)
                    m_node.Logical = checkBoxLogical.Checked;
                if (m_node.Selectable != checkBoxSelectable.Checked)
                    m_node.Selectable = checkBoxSelectable.Checked;
                if (m_node.XMoveable != checkBoxXMoveable.Checked)
                    m_node.XMoveable = checkBoxXMoveable.Checked;
                if (m_node.YMoveable != checkBoxYMoveable.Checked)
                    m_node.YMoveable = checkBoxYMoveable.Checked;
                if (m_node.XSizeable != checkBoxXSizeable.Checked)
                    m_node.XSizeable = checkBoxXSizeable.Checked;
                if (m_node.YSizeable != checkBoxYSizeable.Checked)
					m_node.YSizeable = checkBoxYSizeable.Checked;
				if (m_node.InLinkable != checkBoxInLinkable.Checked)
					m_node.InLinkable = checkBoxInLinkable.Checked;
				if (m_node.OutLinkable != checkBoxOutLinkable.Checked)
                    m_node.OutLinkable = checkBoxOutLinkable.Checked;
                if (m_node.HighlightChildren != checkBoxHighlightChildren.Checked)
                    m_node.HighlightChildren = checkBoxHighlightChildren.Checked;
                if (m_node.RemoveChildren != checkBoxRemoveChildren.Checked)
                    m_node.RemoveChildren = checkBoxRemoveChildren.Checked;
            
				if ((m_node.Text != null && !m_node.Text.Equals(textBoxText.Text)) || 
					(m_node.Text == null && textBoxText.Text != ""))
					m_node.Text = textBoxText.Text;
				if ((m_node.Tooltip != null && !m_node.Tooltip.Equals(textBoxTooltip.Text)) || 
					(m_node.Tooltip == null && textBoxTooltip.Text != ""))
					m_node.Tooltip = textBoxTooltip.Text;
				if ((m_node.Url != null && !m_node.Url.Equals(textBoxUrl.Text)) || 
					(m_node.Url == null && textBoxUrl.Text != ""))
					m_node.Url = textBoxUrl.Text;

                if (m_node.ImageIndex.ToString() != textBoxImageIndex.Text)
                    m_node.ImageIndex = Int32.Parse(textBoxImageIndex.Text);

                if (m_node.FillColor != labelFillColor.BackColor)
                    m_node.FillColor = labelFillColor.BackColor;
                if (m_node.DrawColor != labelDrawColor.BackColor)
                    m_node.DrawColor = labelDrawColor.BackColor;
                if (m_node.TextColor != labelTextColor.BackColor)
					m_node.TextColor = labelTextColor.BackColor;
				if (m_node.GradientColor != labelGradientColor.BackColor)
					m_node.GradientColor = labelGradientColor.BackColor;

                if (m_node.Font != null)
                {
                    if (!m_node.Font.Equals(textBoxText.Font))
                        m_node.Font = textBoxText.Font;
                }
                else if (textBoxText.Font != null)
                    m_node.Font = textBoxText.Font;

                m_node.Refresh();
            }
            else
            {
                if (m_addflow.DefNodeProp.Shape.Orientation != shapeorientation || 
                    m_addflow.DefNodeProp.Shape.Style != shapestyle)
                    m_addflow.DefNodeProp.Shape = new Shape(shapestyle, shapeorientation);
                if (m_addflow.DefNodeProp.Shadow.Style != shadowstyle || m_addflow.DefNodeProp.Shadow.Color != shadowcolor)
                {
                    m_addflow.DefNodeProp.Shadow.Style = shadowstyle;
                    m_addflow.DefNodeProp.Shadow.Color = shadowcolor;
                }

                if (m_addflow.DefNodeProp.DashStyle != (DashStyle)comboBoxDashStyle.SelectedIndex)
                    m_addflow.DefNodeProp.DashStyle = (DashStyle)comboBoxDashStyle.SelectedIndex;
                if (m_addflow.DefNodeProp.DrawWidth != comboBoxPenWidth.SelectedIndex)
                    m_addflow.DefNodeProp.DrawWidth = comboBoxPenWidth.SelectedIndex;
                if (m_addflow.DefNodeProp.ImagePosition != (ImagePosition)comboBoxImagePosition.SelectedIndex)
                    m_addflow.DefNodeProp.ImagePosition = (ImagePosition)comboBoxImagePosition.SelectedIndex;
                if (m_addflow.DefNodeProp.Alignment != (Alignment)comboBoxAlignment.SelectedIndex)
                    m_addflow.DefNodeProp.Alignment = (Alignment)comboBoxAlignment.SelectedIndex;
                if (m_addflow.DefNodeProp.AutoSize != (AutoSize)comboBoxAutoSize.SelectedIndex)
                    m_addflow.DefNodeProp.AutoSize = (AutoSize)comboBoxAutoSize.SelectedIndex;
                if (m_addflow.DefNodeProp.AttachmentStyle != (AttachmentStyle)comboBoxAttachmentStyle.SelectedIndex)
                    m_addflow.DefNodeProp.AttachmentStyle = (AttachmentStyle)comboBoxAttachmentStyle.SelectedIndex;
                if (m_addflow.DefNodeProp.Dock != (DockStyle)comboBoxDock.SelectedIndex)
                    m_addflow.DefNodeProp.Dock = (DockStyle)comboBoxDock.SelectedIndex;
          
                Size sizeMargin = new Size(comboBoxXTextMargin.SelectedIndex, 
                    comboBoxYTextMargin.SelectedIndex);
                if (!m_addflow.DefNodeProp.TextMargin.Equals(sizeMargin))
                    m_addflow.DefNodeProp.TextMargin = sizeMargin;

                if (m_addflow.DefNodeProp.Trimming != (StringTrimming)comboBoxTrimming.SelectedIndex)
					m_addflow.DefNodeProp.Trimming = (StringTrimming)comboBoxTrimming.SelectedIndex;
				if (m_addflow.DefNodeProp.GradientMode != (LinearGradientMode)comboBoxGradientMode.SelectedIndex)
					m_addflow.DefNodeProp.GradientMode = (LinearGradientMode)comboBoxGradientMode.SelectedIndex;

                if (m_addflow.DefNodeProp.LabelEdit != checkBoxLabelEdit.Checked)
                    m_addflow.DefNodeProp.LabelEdit = checkBoxLabelEdit.Checked;
                if (m_addflow.DefNodeProp.Transparent != checkBoxTransparent.Checked)
					m_addflow.DefNodeProp.Transparent = checkBoxTransparent.Checked;
				if (m_addflow.DefNodeProp.Gradient != checkBoxGradient.Checked)
					m_addflow.DefNodeProp.Gradient = checkBoxGradient.Checked;
                if (m_addflow.DefNodeProp.Hidden != checkBoxHidden.Checked)
                    m_addflow.DefNodeProp.Hidden = checkBoxHidden.Checked;
                if (m_addflow.DefNodeProp.OwnerDraw != checkBoxOwnerDraw.Checked)
                    m_addflow.DefNodeProp.OwnerDraw = checkBoxOwnerDraw.Checked;
                if (m_addflow.DefNodeProp.Logical != checkBoxLogical.Checked)
                    m_addflow.DefNodeProp.Logical = checkBoxLogical.Checked;
                if (m_addflow.DefNodeProp.Selectable != checkBoxSelectable.Checked)
                    m_addflow.DefNodeProp.Selectable = checkBoxSelectable.Checked;
                if (m_addflow.DefNodeProp.XMoveable != checkBoxXMoveable.Checked)
                    m_addflow.DefNodeProp.XMoveable = checkBoxXMoveable.Checked;
                if (m_addflow.DefNodeProp.YMoveable != checkBoxYMoveable.Checked)
                    m_addflow.DefNodeProp.YMoveable = checkBoxYMoveable.Checked;
                if (m_addflow.DefNodeProp.XSizeable != checkBoxXSizeable.Checked)
                    m_addflow.DefNodeProp.XSizeable = checkBoxXSizeable.Checked;
                if (m_addflow.DefNodeProp.YSizeable != checkBoxYSizeable.Checked)
					m_addflow.DefNodeProp.YSizeable = checkBoxYSizeable.Checked;
				if (m_addflow.DefNodeProp.InLinkable != checkBoxInLinkable.Checked)
					m_addflow.DefNodeProp.InLinkable = checkBoxInLinkable.Checked;
				if (m_addflow.DefNodeProp.OutLinkable != checkBoxOutLinkable.Checked)
                    m_addflow.DefNodeProp.OutLinkable = checkBoxOutLinkable.Checked;
                if (m_addflow.DefNodeProp.HighlightChildren != checkBoxHighlightChildren.Checked)
                    m_addflow.DefNodeProp.HighlightChildren = checkBoxHighlightChildren.Checked;
                if (m_addflow.DefNodeProp.RemoveChildren != checkBoxRemoveChildren.Checked)
                    m_addflow.DefNodeProp.RemoveChildren = checkBoxRemoveChildren.Checked;
            
				if ((m_addflow.DefNodeProp.Text != null && !m_addflow.DefNodeProp.Text.Equals(textBoxText.Text)) || 
					(m_addflow.DefNodeProp.Text == null && textBoxText.Text != ""))
					m_addflow.DefNodeProp.Text = textBoxText.Text;
				if ((m_addflow.DefNodeProp.Tooltip != null && !m_addflow.DefNodeProp.Tooltip.Equals(textBoxTooltip.Text)) || 
					(m_addflow.DefNodeProp.Tooltip == null && textBoxTooltip.Text != ""))
					m_addflow.DefNodeProp.Tooltip = textBoxTooltip.Text;
				if ((m_addflow.DefNodeProp.Url != null && !m_addflow.DefNodeProp.Url.Equals(textBoxUrl.Text)) || 
					(m_addflow.DefNodeProp.Url == null && textBoxUrl.Text != ""))
					m_addflow.DefNodeProp.Url = textBoxUrl.Text;

                if (m_addflow.DefNodeProp.ImageIndex.ToString() != textBoxImageIndex.Text)
                    m_addflow.DefNodeProp.ImageIndex = Int32.Parse(textBoxImageIndex.Text);

                if (m_addflow.DefNodeProp.FillColor != labelFillColor.BackColor)
                    m_addflow.DefNodeProp.FillColor = labelFillColor.BackColor;
                if (m_addflow.DefNodeProp.DrawColor != labelDrawColor.BackColor)
                    m_addflow.DefNodeProp.DrawColor = labelDrawColor.BackColor;
                if (m_addflow.DefNodeProp.TextColor != labelTextColor.BackColor)
					m_addflow.DefNodeProp.TextColor = labelTextColor.BackColor;
				if (m_addflow.DefNodeProp.GradientColor != labelGradientColor.BackColor)
					m_addflow.DefNodeProp.GradientColor = labelGradientColor.BackColor;

                if (m_addflow.DefNodeProp.Font != null)
                {
                    if (!m_addflow.DefNodeProp.Font.Equals(textBoxText.Font))
                        m_addflow.DefNodeProp.Font = textBoxText.Font;
                }
                else if (textBoxText.Font != null)
                    m_addflow.DefNodeProp.Font = textBoxText.Font;
            }
        }

        private void buttonFillColor_Click(object sender, System.EventArgs e)
        {
            ColorDialog clrdlg = new ColorDialog();
            clrdlg.Color = labelFillColor.BackColor;
            if (clrdlg.ShowDialog() == DialogResult.OK)
                labelFillColor.BackColor = clrdlg.Color;
        }

        private void buttonDrawColor_Click(object sender, System.EventArgs e)
        {        
            ColorDialog clrdlg = new ColorDialog();
            clrdlg.Color = labelDrawColor.BackColor;
            if (clrdlg.ShowDialog() == DialogResult.OK)
                labelDrawColor.BackColor = clrdlg.Color;
        }

        private void buttonTextColor_Click(object sender, System.EventArgs e)
        {        
            ColorDialog clrdlg = new ColorDialog();
            clrdlg.Color = labelTextColor.BackColor;
            if (clrdlg.ShowDialog() == DialogResult.OK)
                labelTextColor.BackColor = clrdlg.Color;
        }

        private void buttonShadowColor_Click(object sender, System.EventArgs e)
        {        
            ColorDialog clrdlg = new ColorDialog();
            clrdlg.Color = labelShadowColor.BackColor;
            if (clrdlg.ShowDialog() == DialogResult.OK)
                labelShadowColor.BackColor = clrdlg.Color;
        }

        private void buttonFont_Click(object sender, System.EventArgs e)
        {            
            FontDialog fontdlg = new FontDialog();
            fontdlg.Font = textBoxText.Font;
            if (fontdlg.ShowDialog() == DialogResult.OK)
                textBoxText.Font = fontdlg.Font;
        }

		private void buttonGradientColor_Click(object sender, System.EventArgs e)
		{
			ColorDialog clrdlg = new ColorDialog();
			clrdlg.Color = labelGradientColor.BackColor;
			if (clrdlg.ShowDialog() == DialogResult.OK)
				labelGradientColor.BackColor = clrdlg.Color;
		}
	}
}
