using System;

namespace Lassalle.GraphAlgo
{
	/// <summary>Represents an edge in the graph.</summary>
	public class Edge
	{
		internal Vertex org;
		internal Vertex dst;
		internal object link;  
		internal bool visited;  
		internal bool used;  
		internal bool inSpanningTree;
		internal bool inPathTree;
		internal int cost;
		internal object tag;      

		public Edge()
		{
			org = null;
			dst = null;
			link = null;
			visited = false;
			inSpanningTree = false;
			inPathTree = false;
			used = false;
			cost = 0;
			tag = null;
		}
		
		/// <summary>Sets or returns a reference to an object associated to the vertex.
		/// </summary>
		public Object Tag
		{
			set { tag = value; }
			get { return tag; }
		}

		public bool InSpanningTree
		{
			get	{ return inSpanningTree; }
		}
		
		public bool InPathTree
		{
			get	{ return inPathTree; }
		}
	}
}
