using System;
using System.Collections;

namespace Lassalle.GraphAlgo
{
	internal enum ShortedPathStatus {NotInList, NowInList, WasInList};

	/// <summary>Represents a vertex in the graph.</summary>
	public class Vertex
	{
		internal ArrayList aEdges; 
		internal int postOrderNumber;
		internal int visitOrderVertex;
		internal bool visited;
		internal bool marked;
		internal bool articulation;
		internal object node; 
		internal int connectedPart;
		internal int biConnectedPart;
		internal object tag;   
		internal int dist;
		internal ShortedPathStatus status;
		internal Edge inEdge;

		/// <summary>Initializes a new instance of the Vertex class.</summary>
		public Vertex()
		{
			aEdges = new ArrayList(); 
			postOrderNumber = 0;
			connectedPart = 0;
			biConnectedPart = 0;
			visitOrderVertex = 0;
			visited = false;
			marked = false;
			articulation = false;
			node = null;
			tag = null;
			dist = 0;
			status = ShortedPathStatus.NotInList;
			inEdge = null;
		}

		public int ConnectedPart
		{
			get	{ return connectedPart; }
		}
		
		public int BiconnectedPart
		{
			get	{ return biConnectedPart; }
		}

		public bool IsArticulation
		{
			get	{ return articulation; }
		}
		
		/// <summary>Sets or returns a reference to an object associated to the vertex.
		/// </summary>
		public Object Tag
		{
			set { tag = value; }
			get { return tag; }
		}
	}
}
