'----------------------------------------------------------------------------------------
' AddFlow for WinForms: CustomShape sample
' Copyright (c) 2003-2011 Lassalle Technologies. All Rights Reserved
' http://www.lassalle.com
' Author: Patrick Lassalle    
' THIS CODE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND EITHER EXPRESSED OR IMPLIED.
'----------------------------------------------------------------------------------------

Imports System
Imports System.Drawing.Drawing2D
Imports Lassalle.Flow

Public Class CustomShape

    Private Sub CustomShape_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Create a graphics path which will be used for the custom shape
        Dim path As GraphicsPath = New GraphicsPath()
        path.AddArc(0, 0, 15, 15, 180, 90)
        path.AddLine(10, 0, 40, 10)
        path.AddLine(40, 10, 50, 0)
        path.AddLine(50, 0, 80, 40)
        path.AddLine(80, 40, 40, 30)
        path.AddLine(40, 30, 0, 40)
        path.AddLine(0, 40, 10, 20)
        path.CloseFigure()
        path.AddEllipse(10, 10, 10, 10)
        path.FillMode = FillMode.Alternate

        AddFlow1.Dock = DockStyle.Fill
        AddFlow1.AutoScroll = True
        AddFlow1.BackColor = Color.White
        AddFlow1.PageUnit = GraphicsUnit.Point
        AddFlow1.DefNodeProp.FillColor = Color.LightCoral
        AddFlow1.DefNodeProp.Shape.Style = ShapeStyle.Custom
        AddFlow1.DefNodeProp.Shape.GraphicsPath = path
        AddFlow1.DefNodeProp.Shadow.Style = ShadowStyle.RightBottom
        AddFlow1.DefNodeProp.Shadow.Color = Color.Silver
        AddFlow1.DefNodeProp.LabelEdit = False

        AddFlow1.DefLinkProp.EndCap = LineCap.ArrowAnchor
        AddFlow1.DefLinkProp.DrawWidth = 4

        Dim node1 As Node = AddFlow1.Nodes.Add(50, 50, 100, 50)
        Dim node2 As Node = AddFlow1.Nodes.Add(350, 50, 50, 50)
        node2.OutLinks.Add(node1)
    End Sub

    Private Sub MenuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAbout.Click
        MsgBox("AddFlow for WinForms: CustomShape Sample" & vbCr & "Copyright  2003-2011 Lassalle Technologies")
      End Sub

    Private Sub MenuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuExit.Click
        End
    End Sub

    Private Sub MenuDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuDelete.Click
        AddFlow1.DeleteSel()
    End Sub

    Private Sub MenuOrientation0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuOrientation0.Click
        AddFlow1.DefNodeProp.Shape.Orientation = ShapeOrientation.so_0
        For Each node As Node In AddFlow1.Nodes
            node.Shape.Orientation = ShapeOrientation.so_0
        Next
    End Sub

    Private Sub MenuOrientation90_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuOrientation90.Click
        AddFlow1.DefNodeProp.Shape.Orientation = ShapeOrientation.so_90
        For Each node As Node In AddFlow1.Nodes
            node.Shape.Orientation = ShapeOrientation.so_90
        Next
    End Sub

    Private Sub MenuOrientation180_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuOrientation180.Click
        AddFlow1.DefNodeProp.Shape.Orientation = ShapeOrientation.so_180
        For Each node As Node In AddFlow1.Nodes
            node.Shape.Orientation = ShapeOrientation.so_180
        Next
    End Sub

    Private Sub MenuOrientation270_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuOrientation270.Click
        AddFlow1.DefNodeProp.Shape.Orientation = ShapeOrientation.so_270
        For Each node As Node In AddFlow1.Nodes
            node.Shape.Orientation = ShapeOrientation.so_270
        Next
    End Sub
End Class
