'----------------------------------------------------------------------------------------
' AddFlow for WinForms: DrawDrop sample
' Copyright (c) 2003-2011 Lassalle Technologies. All Rights Reserved
' http://www.lassalle.com
' Author: Patrick Lassalle    
' THIS CODE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND EITHER EXPRESSED OR IMPLIED.
'----------------------------------------------------------------------------------------

Public Class DragDrop
    Private Sub DragDrop_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        TreeView1.Dock = DockStyle.Left
        Dim node1 As TreeNode = TreeView1.Nodes.Add("node1")
        Dim node2 As TreeNode = TreeView1.Nodes.Add("node2")
        Dim node3 As TreeNode = TreeView1.Nodes.Add("node3")

        AddFlow1.Dock = DockStyle.Fill
        AddFlow1.BackColor = SystemColors.Window
        AddFlow1.AllowDrop = True
        AddFlow1.CanDragScroll = False
        AddFlow1.AutoScroll = False
        AddFlow1.PageUnit = GraphicsUnit.Point
        AddFlow1.DefNodeProp.FillColor = System.Drawing.Color.Aqua
        AddFlow1.DefNodeProp.Shape.Style = Lassalle.Flow.ShapeStyle.Document
    End Sub

    Private Sub ExitMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitMenu.Click
        End
    End Sub

    Private Sub AboutMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutMenu.Click
        MsgBox("AddFlow for WinForms: DragDrop sample" & vbCrLf & "Copyright  2003-2011 Lassalle Technologies")
    End Sub

    Private Sub TreeView1_ItemDrag(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ItemDragEventArgs) Handles TreeView1.ItemDrag
        AddFlow1.DoDragDrop(e.Item, DragDropEffects.Move)
    End Sub

    Private Sub AddFlow1_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles AddFlow1.DragEnter
        Dim treenode As TreeNode = e.Data.GetData("System.Windows.Forms.TreeNode", True)
        If Not (treenode Is Nothing) Then
            e.Effect = DragDropEffects.Move
        End If
    End Sub

    Private Sub AddFlow1_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles AddFlow1.DragDrop
        Dim treenode As TreeNode = e.Data.GetData("System.Windows.Forms.TreeNode", True)
        If Not (treenode Is Nothing) Then
            Dim node As Lassalle.Flow.Node
            Dim ptClient As Point = AddFlow1.PointToClient(New Point(e.X, e.Y))
            Dim ptAddFlow As Point = AddFlow1.PointToAddFlow(ptClient)

            node = AddFlow1.Nodes.Add(ptAddFlow.X, ptAddFlow.Y, 40, 40)
            node.Text = treenode.Text
        End If
    End Sub
End Class
